'BlitzMax 1.20 Heli Sim

'M.Rauch 04.06.2006.1

'if this example running please disable DebugMode because Ground Intersection slows down

'example sync to 100 FPS (10ms) , look at MainLoop()

Strict

Include "MR_Vector.bmx"
Include "MR_3DS.bmx"
Include "MR_OpenGl.bmx"

'#################################################################################################
' Example Example Example Example Example Example Example Example Example Example Example Example
'#################################################################################################

Global glContext:TGraphics=myGraphics(800,600,0,72)
'Global glContext:TGraphics=myGraphics(320,240,0,72)
'Global glContext:TGraphics=myGraphics(800,600,16,72) 'Full Screen

Global Entitys:TEntityList=TEntityList.Create()  '<- da mssen die Dinger rein sonnst werden die nicht angezeigt
Global Entity:TEntity
Global Mesh:TMesh
Global Surface:TSurface
Global Vertex:TVertex

Global Lines:TList=CreateList()

'-------------------------------------- Sound

Global sndHeli:TSound=LoadSound("Snd\gheli1.wav",True)
Global sndCrash:TSound=LoadSound("Snd\crash.wav")
Global sndHit:TSound=LoadSound("Snd\hit.wav")
Global sndKlack:TSound=LoadSound("Snd\Klack.wav")
Global sndMenu:TSound=LoadSound("Snd\MenuMove.wav")
Global sndWarning:TSound=LoadSound("Snd\WarnSignal2.wav",True)

'-------------------------------------- Light 0-7

MakeLight()

'-------------------------------------- Collision Types

Const ColliTypeCube=2
Const ColliTypeBellBody=1
Const ColliTypeGround=3
Const ColliTypeLandingZone=4
Const ColliTypeBellKufe=5

'-------------------------------------- Landing Zone

Global LandingZone:TEntity=Entitys.LoadStatic3DS("Obj\LandingZone\LandingZone.3ds") 
LandingZone.ColliType=ColliTypeLandingZone
 
'-------------------------------------- Sky

Global TexSky:TTexture=TTexture.Load("SKY2.bmp")
Global MySky:TEntity=Entitys.LoadStatic3DS("Obj\Sky\Sky.3ds") 

If 1=1 Then

 For Mesh=EachIn MySky.Meshes
  Mesh.NoCompile
  Mesh.Scale 20000,8000,20000
  Mesh.SetTexture TexSky,5,5
  Mesh.SetEmission 1,1,1,1
 Next
 'Mesh.Compile 'den Himmel nicht weil sonnst kann man die Texture nicht bewegen !
 MySky.Rotate 0,45,0

EndIf

'-------------------------------------- Mountains

If 1=1 Then

Global texberge:TTexture=TTexture.Load("Berge.png",0,0,0)
texberge.SetTextureScale 1,1
texberge.SetClamp True,True
Global MyMountain:TEntity=TEntity.Create(0,0,0) 
Entitys.EntityAdd MyMountain
Mesh=MyMountain.CreateMesh()
Mesh.AddTerrainBorder(100000,25000)
Mesh.SetTexture texberge
Mesh.SetEmission 1,1,1,1
Mesh.Compile

EndIf

'-------------------------------------- Terrain
Global MyGround:TEntity[4]
Global texh:TTexture=TTexture.Load("Terrain.jpg")
MyGround[0]=TEntity.Create(0,0,0)
'MyGround[0]=TEntity.Create(-25000,0,-25000) 'for a 4x4 Terrain
'MyGround[1]=TEntity.Create( 25000,0,-25000)
'MyGround[2]=TEntity.Create( 25000,0, 25000)
'MyGround[3]=TEntity.Create(-25000,0, 25000)
If 1=1 Then
Entitys.EntityAdd MyGround[0]
'Entitys.EntityAdd MyGround[1]
'Entitys.EntityAdd MyGround[2]
'Entitys.EntityAdd MyGround[3]

Mesh=MyGround[0].CreateMesh()
'Mesh.AddHeightMap "HMap.bmp",50000,2000 '4x4
Mesh.AddHeightMap "HMap.bmp",100000,2000 '1x
Mesh.SetTexture texh,20,20
'Mesh.SetAmbient 0.0,0.0,0.0,1
'Mesh.SetDiffuse 1,1,1,1
Mesh.SetEmission 0.5,0.5,0.5,1
'Mesh.SetShininess 0,0,0,1
'Mesh.SetSpecular 0,0,0,1
Mesh.Compile

'MyGround[0].ShowBoundingSphere=True
MyGround[0].ColliType=ColliTypeGround
'MyGround[1].ColliType=ColliTypeGround
'MyGround[2].ColliType=ColliTypeGround
'MyGround[3].ColliType=ColliTypeGround

'Mesh=Mesh.Copy()
'Mesh.FlipVertices -1,1,1
'Mesh.Compile
'MyGround[1].AddMesh(Mesh)

'Mesh=Mesh.Copy()
'Mesh.FlipVertices 1,1,-1
'Mesh.Compile
'MyGround[2].AddMesh(Mesh)

'Mesh=Mesh.Copy()
'MyGround[3].AddMesh(Mesh)
'Mesh.FlipVertices -1,1,1
'Mesh.Compile

EndIf

'-------------------------------------- Scene

'Global Bridge:TEntity=Entitys.LoadStatic3DS("Obj\Bridge\Bridge.3ds")
'Bridge.pos.set 0,500,-5000

'-------------------------------------- Crates
Global MyCrates:TEntity[20]
MakeCrates MyGround[0]

'#################################################################################################
' Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main Main
'#################################################################################################

MainLoop()
Entitys.FreeAllTextures
TEntityList.Free Entitys

EndGraphics() 
End

'---------------------------------------------------------------

Function MainLoop()
 Local UseJoy:Int=1 'don't combine Joystick and Keys for the same movement !!!
 Local CamMode:Int=1
 Local ShowHelp:Int=1
 Local w:Double
 Local u:Double
 Local v:Double
 Local nr:Int
 Local CamX:Double'for special rotation the cam :-)
 Local CamY:Double
 Local CamZ:Double
 Local rspeed:Double=0
 Local Turn:Double
 Local BBoxToggle:Int=0
 Local Engine=1
 Local Line3D:TLine
 Local t1:Float
 Local timed:Float
 Local fps:String

 Local chHeli:TChannel=PlaySound(sndHeli)
 chHeli.SetVolume 0.0
 chHeli.SetRate 1
   
 '-------------------------------------- Heli

 Local bell:TEntity=Entitys.Load3DS("Obj\Bell\Bell.3ds",1)
 
 Local bellkufen:TEntity=Entitys.EntityFindChild(bell,"Kufen")

 Local bellHauptRotor:TEntity=Entitys.EntityFindChild(bell,"HauptRotor")
 Local bellPlatteHR:TEntity=Entitys.EntityFindChild(bell,"PlatteHR")
 Local bellHeckRotor:TEntity=Entitys.EntityFindChild(bell,"HeckRotor")
 Local bellGlas:TEntity=Entitys.EntityFindChild(bell,"Glas")
 Local bellBody:TEntity=Entitys.EntityFindChild(bell,"Body")
 Local bellGummi:TEntity=Entitys.EntityFindChild(bell,"Gummi")
 Local bellCokpit:TEntity=Entitys.EntityFindChild(bell,"Cokpit")
 Local bellRueckwand:TEntity=Entitys.EntityFindChild(bell,"Rueckwand")

 Local PMCokpit:TPixmap=LoadPixmap("Cokpit.bmp")
 Local TexCokpit:TTexture=TTexture.CreateFromPixmap(PMCokpit)
 For Mesh=EachIn bellCokpit.Meshes
  Mesh.NoCompile
  Mesh.SetTexture TexCokpit
 Next
 TexCokpit.UpdateFromPixmap PMCokpit

 bellkufen.SetMeshesDiffuseColor 0.8,0.8,0.8,1
 bellHauptRotor.SetMeshesDiffuseColor 0.1,0.1,0.1,1
 bellHeckRotor.SetMeshesDiffuseColor 0.1,0.1,0.1,1

 For Mesh=EachIn bellCokpit.Meshes
  Mesh.NoCompile
  Mesh.SetAmbient 0.13,0.13,0.13,1
  Mesh.SetDiffuse 0.78,0.78,0.78,1
  Mesh.SetShininess 0.5,0.5,0.5,1
  Mesh.SetEmission 0.5,0.5,0.5,1
  Mesh.Compile
 Next

 bellRueckwand.SetMeshesDiffuseColor 0.78,0.78,0.39,1

 bellGummi.SetMeshesDiffuseColor 0.1,0.1,0.1,1

 For Mesh=EachIn bellBody.Meshes
  Mesh.NoCompile
  Mesh.SetAmbient 0.13,0.13,0.13,1
  Mesh.SetDiffuse 0.78,0.78,0.39,1
  Mesh.SetShininess 0.5,0.5,0.5,1
  Mesh.Compile
 Next

 For Mesh=EachIn bellGlas.Meshes
  Mesh.NoCompile
  Mesh.SetAmbient 0.1,0.1,0.1,1
  Mesh.SetDiffuse 0.9,0.9,0.9,0.25
  Mesh.SetEmission 0,0,0,0
  Mesh.SetShininess 0.5,0.5,0.5,1
  Mesh.SetSpecular 0.1,0.1,0.1,1
  Mesh.Compile
 Next

 bellGummi.SetMeshesFaces 1,1
 bellBody.SetMeshesFaces 1,1
 bellGlas.SetMeshesFaces 1,1

 Local CamEntity:TEntity '
 CamEntity=TEntity.Create(0,-120,-170,Bell) 'in Cockpit <-----------------<<<
 Local CamEntity2:TEntity 
 CamEntity2=TEntity.Create(0,25,0,Bellkufen) '<-----------------<<<
 CamEntity2.Rotate -15.0,0,0

 Local CamEntity3:TEntity 
 CamEntity3=TEntity.Create(0,300,0,bellPlatteHR) '<-----------------<<<
 CamEntity3.Rotate 90.0,0,0

 Local Font:T3DFont=T3DFont.Create("BMPFont\Haettenschweiler24.bmp")
 Font.SetAllCharAlpha 0.85
 'BlitzLogo as Add Char :)
 Font.LoadCharImage "@","BMax.png",128,128,0.75
 '--------------------------------------

 Entitys.SetBoundingBoxesFromMesh
 Entitys.SetBoundingSpheresFromMesh
 Entitys.ShowAxisOnOff 0

 MyGround[0].IntersectTree=TIntersectTree.Create(MyGround[0]) '<---

 bellBody.ColliType=ColliTypeBellBody
 bellkufen.ColliType=ColliTypeBellKufe

 HeliLandingZoneHeight()

 Bell.Position 0,LandingZone.pos.y-bellkufen.pos.y,0

 While Not KeyHit(KEY_ESCAPE)

  t1 = MilliSecs()

	glClear GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT	'Clear The Screen And The Depth Buffer

    Entitys.SphereCollisionFlagClear

    ClearList Lines

    '-------------------------------------------------------- Steuerung

    If Engine Then  
     If KeyDown(KEY_NUMADD)=True Then '+
      If rspeed<50 Then rspeed=rspeed+0.1 
     EndIf
     If KeyDown(KEY_NUMSUBTRACT)=True Then '-
      rspeed=rspeed-0.1 
     EndIf
    EndIf

    Entitys.SphereCollisionTest ColliTypeBellKufe,ColliTypeLandingZone

    If UseJoy Then
     If Engine Then  
      If JoyZ()<0.1 Then '+
       If rspeed<35 Then rspeed=rspeed+Abs(JoyZ())/20.0
      EndIf
      If JoyZ()>0.1 Then '-
       If rspeed>25 Then rspeed=rspeed-Abs(JoyZ())/20.0 
      EndIf
     EndIf
     'Z
     If Abs(JoyX())>0.05 And (rspeed>20) And LandingZone.ColliSphere=0 Then
      Turn= JoyX(); Bell.Turn 0,0,Turn*2.0;CamZ=CamZ+Turn*4.0
     Else
      StableZ Bell,45.0
     EndIf
     'X
     If Abs(JoyY())>0.05 And (rspeed>20) Then 'And LandingZone.ColliSphere=0
      Turn=-JoyY(); Bell.Turn Turn*2.0,0,0;CamX=CamX+Turn*2.0
     Else
      StableX Bell,45.0
     EndIf
     'Y
     If Abs(JoyR())>0.05 And (rspeed>20) Then
      Turn= JoyR(); Bell.Turn 0,Turn*2.0,0;CamY=CamY+Turn*4.0
     EndIf
     'B1 Links B2 Rechts
     If JoyDown(0)=True And (rspeed>20) Then Turn= -1; Bell.Turn 0,Turn*2.0,0;CamY=CamY+Turn*4.0
     If JoyDown(1)=True And (rspeed>20) Then Turn=  1; Bell.Turn 0,Turn*2.0,0;CamY=CamY+Turn*4.0
    Else 'Keys
     If KeyDown(KEY_UP)  =True Then
      Bell.Turn  2,0,0
     ElseIf KeyDown(KEY_DOWN)=True Then
      Bell.Turn -2,0,0
     Else
      StableX Bell,45.0
     EndIf
     'Links Rechts Y
     If KeyDown(KEY_LEFT) =True Then Bell.Turn 0,-2,0
     If KeyDown(KEY_RIGHT)=True Then Bell.Turn 0, 2,0
     'Entf Ende Z
     If KeyDown(KEY_DELETE)=True Then
      Bell.Turn 0,0,-2
     ElseIf KeyDown(KEY_END)=True Then
      Bell.Turn 0,0, 2
     Else
      StableZ Bell,45.0
     EndIf
     'Translate 1,2
     If KeyDown(KEY_1)=True Then bellHauptRotor.Translate 0, 1,0 
     If KeyDown(KEY_2)=True Then bellHauptRotor.Translate 0,-1,0 
    EndIf

    If KeyHit(KEY_ENTER)>0 Then 'RESET TO START :)
     engine=0
     rspeed=0
     Bell.Position 0,LandingZone.pos.y-bellkufen.pos.y,0
     Bell.Rotate 0,0,0
    EndIf

    bellHauptRotor.Turn 0,-rspeed,0 'Negativ um Y
    bellHeckRotor.Turn rspeed,0,0   'Positiv um X

    '-------------------------------------------------------- Heli Sound

    'chWind.SetVolume QLimit(Abs(rspeed) / 100.0,0.05,1.0)
    chHeli.SetVolume QLimit(Abs(rspeed) / 100.0,0.0 ,1.0)
    chHeli.SetRate QLimit(Abs(rspeed) / 100.0*1.5,1.0/4.0,1.5)

    '--------------------------------------------------------------------

    If KeyHit(KEY_E)>0 Then engine=1-engine
    If engine Then
     'Speed up to fly
     If rspeed<25 Then rspeed=rspeed+0.1
    Else
     'slow down
     If rspeed>0 Then rspeed=rspeed-0.05;If rspeed<0 Then rspeed=0
    EndIf

    If rspeed>10 Then
     bell.Move 0,(rspeed-10.0)*5.0,0
    EndIf

    '-------------------------------------------------------------------- Gravitation
    Bell.Translate 0,(-981/10.0),0

    If LandingZone.ColliSphere=1 Then 'hit the platform
     bellkufen.GetGlobalPos
     StableX Bell,10.0
     StableZ Bell,10.0
     If bellkufen.GlobalPos.y<LandingZone.pos.y Then 'Stay on Platform
      Bell.Translate 0,(LandingZone.pos.y-bellkufen.GlobalPos.y),0
     EndIf
    Else
     If 1=1 Then '<-- Ray Intersect Ground (128x128 Vertices /4 each quad has 2 Triangles=8192 Intersection tests!)
      If Bell.pos.y<=MyGround[0].BBoxT1.y Then 'above is no Terrain
       bellkufen.GetGlobalPos
       Local y:Double=0
       If TerrainHeight(MyGround[0],bellkufen.GlobalPos.x,y,bellkufen.GlobalPos.z)=True Then
        y=y+100.0
        If bellkufen.GlobalPos.y<y Then 'Stay on Ground
         StableX Bell,10.0
         StableZ Bell,10.0
         Bell.Translate 0,(y-bellkufen.GlobalPos.y),0
        EndIf 'Below Ground
       EndIf
      EndIf 'min. Height
     EndIf 'Enabled Terrain Test
    EndIf

    '-------------------------------------------------------- Limit Bell in Scene

    Bell.PositionLimitX -50000, 50000
    Bell.PositionLimitY    500, 35000
    Bell.PositionLimitZ  50000,-50000

    '-------------------------------------------------------- Bounding Spheres
    If KeyHit(KEY_B)>0 Then
     BBoxToggle=1-BBoxToggle
     bellkufen.ShowBoundingBox=BBoxToggle
     bellkufen.ShowBoundingSphere=BBoxToggle
     bellBody.ShowBoundingBox=BBoxToggle
     bellBody.ShowBoundingSphere=BBoxToggle
     LandingZone.ShowBoundingSphere=BBoxToggle
     MyGround[0].ShowBoundingBox=BBoxToggle
    If MyCrates[0]<>Null Then MyCrates[0].ShowBoundingSphere=BBoxToggle
    EndIf
    '-------------------------------------------------------- Camera

    If KeyHit(KEY_F2)>0 Then CamMode=1
    If KeyHit(KEY_F3)>0 Then CamMode=2
    If KeyHit(KEY_F4)>0 Then CamMode=3
    If KeyHit(KEY_F5)>0 Then CamMode=4

    Select CamMode
    Case 1
     Camera -750+LandingZone.pos.x,LandingZone.pos.y+120,LandingZone.pos.z+750 , Bell.Pos.x,Bell.Pos.y,Bell.Pos.z
    Case 2
     CamEntity.Rotate -15.0+CamX,CamY,CamZ
     CameraLikeEntity CamEntity 'Cockpit
    Case 3
     CameraLikeEntity CamEntity2 '__>
    Case 4
     CamEntity3.Rotate 90.0-CamX*8.0,0,0
     CameraLikeEntity CamEntity3 '-+- down
    End Select

    '-------------------------------------------------------- Collision

    'Entitys.SphereCollisionTest ColliTypeBellBody,ColliTypeCube 
    Entitys.SphereCollisionTest ColliTypeBellKufe,ColliTypeCube

    Local Colli:TCollision
    For Colli=EachIn Entitys.EntitysSphereCollision
     'Colli.EntityB.Enabled=0
     Entitys.EntityFree Colli.EntityB
     If sndHit Then PlaySound sndHit
    Next

    '-------------------------------------------------------- Render World

    Entitys.Render

    'This works only from outer Cam
    'For Line3D=EachIn Lines
    ' Line3D.Render
    'Next

    'MyGround[0].IntersectTree.Render

    '-------------------------------------------------------- Something

    CamX=CamX*0.9
    CamY=CamY*0.9
    CamZ=CamZ*0.9

    w=w+1.0;If w>360.0 Then w=w-360.0
    u=u+0.0005;If u>1.0 Then u=u-1.0
    v=v+0.00025;If v>1.0 Then v=v-1.0
    TexSky.SetTexturePos u,v

    If KeyHit(KEY_J)>0 Then UseJoy=1-UseJoy 

    '-------------------------------------------------------- Text output

    If KeyHit(KEY_F1)>0 Then ShowHelp=1-ShowHelp

    If ShowHelp Then

     Font.Render "@",0,-180,CamX,CamY,CamZ

     If UseJoy Then
      Font.Render "J again for Keyboard",0,150,CamX,CamY,CamZ
     Else
      Font.Render "Press J for Joy Input and special rotation camera :)",0,150,CamX,CamY,CamZ,0.75,0.75
      Font.Render "Keys are Cursor Up,Down,Left,Right,Del,End,NUM +,NUM -,E,B,F1",0,175,CamX,CamY,CamZ,0.75,0.75
     EndIf 

     Font.Render "F2,F3,F4,F5 = Camera",0,200,CamX,CamY,CamZ

    EndIf 'Help

    If engine Then
     Font.Render "Speed "+Int(rspeed),0,220,0,0,0,0.75,0.75
    Else
     Font.Render "Engine is off , press E to start",0,220,0,0,0,0.75,0.75
    EndIf

    '-------------------------------------------------------- Show the Backbuffer and free the temponary used Memory

    'FlushMem gone by BMax 1.12 :)

    While Abs(MilliSecs() - t1) < 10.0 'schneller als 1/50 sekunde = 20 ms ??? :-) Dann kurze Pause machen !     
     'wenn man hier End einbaut und das Programm sich beenden ist der Computer schnell genug ;-)
     'nix machen :-)
    Wend

    timed=Abs(MilliSecs() - t1)/1000.0
    fps=Int(1.0/timed)
    Font.Render "FPS "+fps,-180,-180

    Flip 

 Wend
End Function

'---------------------------------------------------------

Function StableZ(Bell:TEntity,Slow:Double)

 'Fligth stabilisation at Z Axis

 Local Turn:Double
 Local Winkel:Double
 Winkel=ATan2(Bell.AchseY.Y,Bell.AchseY.X)-90.0
 If Abs(Winkel)>1.0 Then
  Turn=-Winkel/Slow
  Bell.Turn 0,0,Turn
 EndIf
End Function

'---------------------------------------------------------

Function StableX(Bell:TEntity,Slow:Double)

 'Fligth stabilisation at X Axis

 Local Turn:Double
 Local Winkel:Double
 Winkel=ATan2(Bell.AchseY.Y,Bell.AchseY.Z)-90.0
 If Abs(Winkel)>1.0 Then
  Turn=Winkel/Slow
  Bell.Turn Turn,0,0
 EndIf
End Function

'---------------------------------------------------------

Function QLimit:Double(x:Double,a:Double,b:Double)

 'MR 26.04.2003

 If x>b Then Return b
 If x<a Then Return a
 
 Return x

End Function

'---------------------------------------------------------

Function MakeCrates(Ground:TEntity)

 If Ground=Null Then Return 0

 Local P:TV3D=TV3D.Create() 'Start
 Local T:TV3D=TV3D.Create() 'Target
 Local D:TV3D=TV3D.Create(0,-1,0) 'Direction
 Local Mesh:TMesh

 Local i:Int
 For i=0 To 19
  T.Set(Rand(-25000,25000),0,Rand(-25000,25000))
  P.Set(T.x,100000,T.z)
  If Ground.RayIntersectMeshes(P,D,T,200000)=True
   'DebugLog "Ground Intersect for Crate" 
  EndIf
  'DebugLog t.x+","+t.y+","+t.z

  MyCrates[i]=Entitys.LoadStatic3DS("Obj\Crate\Crate.3ds") 'TEntity.Create(T.x,T.y+100,T.z)
  MyCrates[i].Pos.Set T.x,T.y+100,T.z
  MyCrates[i].Rotate 0,i*10.0,0
  MyCrates[i].ColliType=ColliTypeCube 
  'Entitys.EntityAdd MyCrates[i]
  'Mesh=MyCrates[i].CreateMesh()
  'Mesh.AddCube 200,200,200
  'Mesh.SetDiffuseColor Rand(0.0,1.0),Rand(0.0,1.0),Rand(0.0,1.0)
  'Mesh.Compile
 Next

 P=Null
 T=Null
 D=Null

 Return 1

End Function

'---------------------------------------------------------

Function HeliLandingZoneHeight()

 If MyGround[0]=Null Then
  LandingZone.Position 0,100,0
  Return 0
 EndIf

 Local P:TV3D=TV3D.Create() 'Start
 Local T:TV3D=TV3D.Create() 'Target
 Local D:TV3D=TV3D.Create(0,-1,0) 'Direction

  T.Set(0,0,0)
  P.Set(LandingZone.pos.x,100000,LandingZone.pos.z)
  If MyGround[0].RayIntersectMeshes(P,D,T,200000)=True
   'DebugLog "Ground Intersect for Heli Landing Zone Height" 
   'DebugLog t.x+","+t.y+","+t.z
   LandingZone.Position t.x,t.y+50,t.z
  EndIf

 DebugLog "Highest Point in Terrain "+MyGround[0].BBoxT1.y

 P=Null
 T=Null
 D=Null

End Function

'---------------------------------------------------------

Function MakeLight()

 'GL_AMBIENT
 'GL_DIFFUSE
 'GL_SPECULAR
 'GL_EMISSION
 'GL_SHININESS
 'GL_AMBIENT_AND_DIFFUSE

 glEnable(GL_LIGHTING)	'Licht wird wohl immer benutzt

 glEnable(GL_LIGHT0)

 Local p:Float[4]

 p[0]=1000 
 p[1]=30000
 p[2]=1000
 p[3]=1

 glLightfv(0,GL_POSITION,p)

 p[0]=0.8
 p[1]=0.8
 p[2]=0.8
 p[3]=1

 glLightfv(0,GL_SPECULAR,p)
 glLightfv(0,GL_DIFFUSE,p)
 glLightfv(0,GL_EMISSION,p)
 'glLightfv(0,GL_SHININESS,p)

 p[0]=0.1 
 p[1]=0.1
 p[2]=0.1
 p[3]=1
 glLightfv(0,GL_AMBIENT,p)

 'GL_AMBIENT  (0.0, 0.0, 0.0, 1.0)  ambient intensity 
 'GL_DIFFUSE (1.0, 1.0, 1.0, 1.0)  diffuse intensity 
 'GL_SPECULAR (1.0, 1.0, 1.0, 1.0)  specular intensity 
 'GL_POSITION (0.0, 0.0, 1.0, 0.0)  (x, y, z, w) position of light 
 'GL_SPOT_DIRECTION (0.0, 0.0, -1.0)  direction of spot light 

End Function

'---------------------------------------------------------

Function TerrainHeight:Double(Ground:TEntity,x:Double,y:Double Var,z:Double)

 If Ground=Null Then Return 0
 If Ground.IntersectTree=Null Return 0

 Local P:TV3D=TV3D.Create() 'Start
 Local T:TV3D=TV3D.Create() 'Target
 Local D:TV3D=TV3D.Create(0,-1,0) 'Direction

 T.Set(x,0,z)
 P.Set(x,5000,z)
 If Ground.IntersectTree.RayIntersect(P,D,T,5000)=True Then 'special :-)
  Lines.AddLast TLine.Create(P,T)
 'If Ground.RayIntersectMeshes(P,D,T,200000)=True Then 'Slow in Debug Mode ;-)
  y=T.y
 EndIf

 P=Null
 T=Null
 D=Null

 Return True

End Function

'End of File
