
'BlitzMax 1.20 OpenGL Module (Include)

'M.Rauch 04.06.2006.1

'don't run direct because the includes are included not here :)

Const GLU_POINT                       = 100010
Const GLU_LINE                        = 100011
Const GLU_FILL                        = 100012
Const GLU_SILHOUETTE                  = 100013

Const DebugLogOpenGLOn=0

'---------------------------------------------------------------
'History
'01.08.2005
'Mesh.FlipVertices
'Mesh.Copy
'Surface.Copy
'Vertex.Copy
'Mesh.ScaleMesh is now Mesh.Scale
'TEntity has now a Position Vector 
'TEntity SetBoundingBox
'TEntity SetBoundingBoxFromMesh
'TTexture Clamp U,V for non tiling textures like skyboxes
'06.08.2005
'TEntity SetBoundingSphere
'TEntity SetBoundingSphereFromMesh
'24.08.2005
'TEntity Translate
'27.08.2005
'TEntityList.ShowAxisOnOff
'TEntityList.ShowBoundingBoxesOnOff
'TEntityList.ShowBoundingSpheresOnOff
'TEntityList.SetBoundingBoxesFromMesh
'TEntityList.SetBoundingSpheresFromMesh
'TEntityList Sphere/Sphere Collision List
'TEntityList.SphereCollisionFlagClear
'Change Float to Double !
'TEntity.RayIntersectMeshes <- look inside this func.

'31.08.2005
'TLine is new for Render Ray Lines
'TSurface GetTriangleList works for Triangles and Quads !
'TIntersectTree is new for static non rotated Entitys like Terrains
'03.09.2005
'TVertex.Free
'TSurface.Free
'TMesh.Free
'TEntity.Free
'TIntersectTree.Free
'TTriangle.Free
'TLine.Free
'TCollision.Free
'TEntityList.Free
'TEntityList.EntityFree
'T3DFont.Free
'TEntityList.LoadStatic3DS as Single Mesh :)
'TEntityList.FreeAllTextures
'24.11.2005
'update to BlitzMax 1.12
'GLGraphics are now used from BMax , please use myGraphics
'FlushMem removed
'bglTexFromPixmap() is now GLTexFromPixmap()

'04.06.2006
'BMax 1.20
'some Changes :Int() to :Byte Prt()

'--------------------------------------------------------------

'Strict

'Include "MR_Vector.bmx"
'Include "MR_3DS.bmx"

Global TextureList:TList=CreateList()

'##############################################################################

Type TLine
 Field V1:TV3D
 Field V2:TV3D

 Function Create:TLine(V1:TV3D,V2:TV3D)
  Local L:TLine=New TLine
  L.V1=V1
  L.V2=V2
  Return L
 End Function 

 Function Free(L:TLine Var)
  L.V1=Null
  L.V2=Null
  L=Null
 End Function 
 
 Method Render()
   glPushMatrix()

   Local l:Int
   l=glIsEnabled(GL_LIGHTING)
   If l Then glDisable GL_LIGHTING
   glBegin( GL_LINES )        
    glColor3d( 0.0, 1.0, 1.0 ) 'cyan
    glVertex3d(V1.x,V1.y,V1.z)
    glVertex3d(V2.x,V2.y,V2.z)
   glEnd()
   
   glPopMatrix()
   If l Then glEnable GL_LIGHTING

 End Method

End Type

'##############################################################################

Type TEntityList
 Field Entitys:TList
 Field EntitysSphereCollision:TList

 Function Create:TEntityList()
  Local EL:TEntityList=New TEntityList
  EL.Entitys=CreateList()
  EL.EntitysSphereCollision=CreateList()
  Return EL
 End Function

 Function Free(EL:TEntityList Var)
  Local E:TEntity
  For E=EachIn EL.Entitys
   TEntity.Free E
  Next 
  EL.Entitys=Null
  Local Collision:TCollision
  For Collision=EachIn EL.EntitysSphereCollision
   TCollision.Free Collision
  Next
  EL.EntitysSphereCollision=Null
  EL=Null
 End Function

 Method FreeAllTextures()
  Local T:TTexture
  For T=EachIn TextureList
   TTexture.Free T
  Next
 End Method 

 Method EntityAdd(Entity:TEntity)
  Entitys.Addlast Entity
 End Method

 Method EntityFree(E:TEntity Var)
  Entitys.Remove E
  TEntity.Free E
 End Method

 Method EntityFind:TEntity(Name$)
  Local E:TEntity
  For E=EachIn Entitys
   If E.Name$=Name$ Then Exit 
  Next
  Return E
 End Method

 Method EntityFindChild:TEntity(Entity:TEntity,Name$)
  Local E:TEntity
  Local EC:TEntity
  Local EF:TEntity
  For E=EachIn Entitys 'All
   If E=Entity Then
    If E.Name$=Name$ Then EF=E;Exit 
    For EC=EachIn Entitys 'Childs
     If EC.Parent=E Then
      EF=EntityFindChild(EC,Name$)
      If EF<>Null Then Return EF
     EndIf
    Next
   EndIf
  Next

  If EF Then DebugLogOpenGL "Find Entity "+Name$

  Return EF
 End Method

 '#####################################################

 Method Load3DS:TEntity(Filename$,Scale:Double=1.0)

  DebugLogOpenGL "Load3DS "+Filename$

  If FileType(Filename$)=0 Then
   DebugLogOpenGL "ERR Load3DS:File not found !? "+Filename$ 
   Return Null
  EndIf

  If FileType(Filename$)=1 Then

   If Lower(ExtractExt(Filename$))<>"3ds" Then
    DebugLogOpenGL "MSG Load3DS:The file extension is not 3ds !? "+Filename$ 
   EndIf

   Load3DSIntoMemory(Filename$)

   DebugLogOpenGL "3DS now in Memory"
  Else
   DebugLogOpenGL "ERR Load3DS:Not a file "+Filename$ 
  EndIf

  DebugLogOpenGL "Convert 3DS now ..."

  '--------------------- bertragen in meine Struktur !
  Local TempEntityList:TList=CreateList()
  Local Entity:TEntity
  Local EntityFirst:TEntity
  Local Mesh:TMesh
  Local Surface:TSurface
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Normal:TVertex=TVertex.Create(0,0,0)
  Local A:TV3D=TV3D.Create()
  Local POS:TV3D=TV3D.Create()
  Local Texture:TTexture
  Local M:TMatrix=New TMatrix

  Local Mesh3DS:T3DSMesh  
  Local Vert13DS:T3DSVert  
  Local Vert23DS:T3DSVert  
  Local Vert33DS:T3DSVert  
  Local An:T3DSAnimation

  'radians*(180/Pi)=degrees
  Local RadiansToDegrees:Double
  RadiansToDegrees=180.0/Pi

  For Mesh3DS=EachIn _3DSMeshList 
   '--------------------- 
   Local PosX:Double=0
   Local PosY:Double=0
   Local PosZ:Double=0
   Local AX:Double=0
   Local AY:Double=0
   Local AZ:Double=0
   Local AR:Double=0

   'set to Key 0 (auf Key 0 setzen)
   For An=EachIn _3DSAnimationList 'not every 3ds have an Anim !
    If Mesh3DS.MeshName$=An.ObjName$ Then
     DebugLogOpenGL Mesh3DS.MeshName$
     PosX=An.PositionArray[0].X*An.ScaleArray[0].x*Scale 'and my own master scale by the Pos. and later the Mesh
     PosY=An.PositionArray[0].Y*An.ScaleArray[0].y*Scale
     PosZ=An.PositionArray[0].Z*An.ScaleArray[0].z*Scale
     AX=An.RotArray[0].Axis_x
     AY=An.RotArray[0].Axis_y
     AZ=An.RotArray[0].Axis_z
     AR=An.RotArray[0].rotation_rads*RadiansToDegrees
     DebugLogOpenGL "Found Mesh Anim Pos/Rot for "+Mesh3DS.MeshName$
     Exit  
    EndIf
   Next
   '---------------------

   Entity=TEntity.Create(PosX,PosZ,-PosY) '<-- !
   'Entity=TEntity.Create(0,0,0) '<-- ! zum testen ohne Parents , die Objekte(Meshes) stehen alle an 0,0,0 und sind nicht gedreht
   If EntityFirst=Null Then
    EntityFirst=Entity '<- merken
    DebugLogOpenGL "First Entity "+EntityFirst.Name$
   EndIf
   Self.EntityAdd Entity
   TempEntityList.addlast Entity 

   Entity.Name$=Mesh3DS.MeshName$

   If AN<>Null Then 'Anim Key 0 found
    A.Set(ax,az,-ay)
    MatrixCreateAxisRotate(A,AR,M)
    VTrans Entity.AchseX,M
    VTrans Entity.AchseY,M
    VTrans Entity.AchseZ,M
    Entity.IDA=An.HierarchyParent
    Entity.IDB=An.HierarchyPos
   Else
    Entity.IDA=-1 'no Parent
   EndIf

   Mesh=Entity.CreateMesh()
   Surface=Mesh.NewSurface(GL_TRIANGLES)

   Local F:Int=0
   Local A:Int,B:Int,C:Int
   Local red:Double,green:Double,blue:Double

   '3DS Vertex Matrix erzeugen
   'Erstmal alles zurck das es den Welt Achsen entspricht und an Pos 0,0,0 !!!
   'Rotate

   M.A[0, 0] = Mesh3DS.AchseXx
   M.A[0, 1] = Mesh3DS.AchseYx
   M.A[0, 2] = Mesh3DS.AchseZx
   M.A[0, 3] = 0
   M.A[1, 0] = Mesh3DS.AchseXy 
   M.A[1, 1] = Mesh3DS.AchseYy
   M.A[1, 2] = Mesh3DS.AchseZy
   M.A[1, 3] = 0
   M.A[2, 0] = Mesh3DS.AchseXz
   M.A[2, 1] = Mesh3DS.AchseYz
   M.A[2, 2] = Mesh3DS.AchseZz
   M.A[2, 3] = 0
   M.A[3, 0] = 0 'in VTrans unbenutzt !!!
   M.A[3, 1] = 0
   M.A[3, 2] = 0
   M.A[3, 3] = 1

   For F=0 To Mesh3DS.NumFaces-1
    A=Mesh3DS.GetFace(F).A
    B=Mesh3DS.GetFace(F).B
    C=Mesh3DS.GetFace(F).C

    Vert13DS=Mesh3DS.GetVertex(A)
    Vert23DS=Mesh3DS.GetVertex(B)
    Vert33DS=Mesh3DS.GetVertex(C)

    Vertex1=TVertex.Create(Vert13DS.X,Vert13DS.z,-Vert13DS.y) 'fuck ! Y=Z And Z=-Y in GL <-- !
    Vertex2=TVertex.Create(Vert23DS.X,Vert23DS.z,-Vert23DS.y)
    Vertex3=TVertex.Create(Vert33DS.X,Vert33DS.z,-Vert33DS.y)

    Vertex1.VertexMove -Mesh3DS.OriginX,-Mesh3DS.OriginZ,Mesh3DS.OriginY 'to Origin
    Vertex2.VertexMove -Mesh3DS.OriginX,-Mesh3DS.OriginZ,Mesh3DS.OriginY 'to Origin
    Vertex3.VertexMove -Mesh3DS.OriginX,-Mesh3DS.OriginZ,Mesh3DS.OriginY 'to Origin

    Vertex1.VertexTransform M 'turn around Origin !
    Vertex2.VertexTransform M 'turn
    Vertex3.VertexTransform M 'turn

    'Now Vertices 1-3 are align to Worldaxis because it will move,rotate later by the Entity Matrix

    If A<Mesh3DS.NumTex Then Vertex1.VertexTexCoords(Mesh3DS.GetTex(A).U,1.0-Mesh3DS.GetTex(A).V)
    If B<Mesh3DS.NumTex Then Vertex2.VertexTexCoords(Mesh3DS.GetTex(B).U,1.0-Mesh3DS.GetTex(B).V)
    If C<Mesh3DS.NumTex Then Vertex3.VertexTexCoords(Mesh3DS.GetTex(C).U,1.0-Mesh3DS.GetTex(C).V)

    TriangleNormal Vertex1,Vertex2,Vertex3,Normal

    Vertex1.VertexNormal(Normal.X,Normal.Y,Normal.Z)
    Vertex2.VertexNormal(Normal.X,Normal.Y,Normal.Z)
    Vertex3.VertexNormal(Normal.X,Normal.Y,Normal.Z)

    If Mesh3DS.GetFace(F).Material<>Null Then
     Surface.DIFFUSE =[Mesh3DS.GetFace(F).Material.DiffuseColour.r ,Mesh3DS.GetFace(F).Material.DiffuseColour.g ,Mesh3DS.GetFace(F).Material.DiffuseColour.b ,1.0]
     'Surface.SPECULAR=[Mesh3DS.GetFace(F).Material.SpecularColour.r,Mesh3DS.GetFace(F).Material.SpecularColour.g,Mesh3DS.GetFace(F).Material.SpecularColour.b,1.0]

     If Mesh3DS.GetFace(F).Material.TextureFile$ Then
      If Surface.Texture=Null Then
       Texture=TTexture.Load(ExtractDir(FileName$) + "\" + Mesh3DS.GetFace(F).Material.TextureFile$)
       Surface.SetTexture Texture
      EndIf
     EndIf
     red=Mesh3DS.GetFace(F).Material.DiffuseColour.r 
     green=Mesh3DS.GetFace(F).Material.DiffuseColour.g
     blue=Mesh3DS.GetFace(F).Material.DiffuseColour.b
     Vertex1.VertexColor(red,green,blue)
     Vertex2.VertexColor(red,green,blue)
     Vertex3.VertexColor(red,green,blue)
    EndIf

    Surface.AddTriangle Vertex3,Vertex2,Vertex1
   Next

   Mesh.Scale Scale,Scale,Scale '<- my own scale , look at pos.
   Mesh.Compile
  Next

  '--------------------------------------------------------
  Local EntityP:TEntity
  For Entity=EachIn TempEntityList 
   If Entity.IDA=65535 Then Entity.IDA=-1 'no Parent
  Next
  '--------------------------------------------------------
  'Cinema exports always a Key 0 , so be sure the first obj is a Null-Objekt
  If ListIsEmpty(_3DSAnimationList) Then
   DebugLogOpenGL "no Hirachiy"
     'not tested ... parent is allways the first Entity
	 For Entity=EachIn TempEntityList 
      If Entity<>EntityFirst Then
       Entity.Parent=EntityFirst 
      EndIf
	 Next
  Else  
     DebugLogOpenGL "make Hirachiy"
	 For Entity=EachIn TempEntityList 
	  If Entity.IDA=>0 Then 'hat ein Parent
      DebugLogOpenGL "search Parent for "+Entity.Name$
	  For EntityP=EachIn TempEntityList 
	   If Entity<>EntityP Then
	    If Entity.IDA=EntityP.IDB And Entity.IDA=>0 Then
	     Entity.Parent=EntityP
	     DebugLogOpenGL Entity.Name$+" Parent is "+EntityP.Name$
	     Exit
	    EndIf
	   EndIf
	  Next
	  EndIf
	 Next
  EndIf 'Anim or not	
  '--------------------------------------------------------

  TempEntityList=Null
  M=Null
  Normal=Null
  A=Null
  POS=Null

  Free3DSMemory

  DebugLogOpenGL "Load3DS finish"

  Return EntityFirst

 End Method

 '#####################################################

 Method LoadStatic3DS:TEntity(Filename$,Scale:Double=1.0)

  DebugLogOpenGL "LoadStatic3DS "+Filename$

  If FileType(Filename$)=0 Then
   DebugLogOpenGL "ERR LoadStatic3DS:File not found !? "+Filename$ 
   Return Null
  EndIf

  If FileType(Filename$)=1 Then

   If Lower(ExtractExt(Filename$))<>"3ds" Then
    DebugLogOpenGL "MSG LoadStatic3DS:The file extension is not 3ds !? "+Filename$ 
   EndIf

   Load3DSIntoMemory(Filename$)

   DebugLogOpenGL "3DS now in Memory"
  Else
   DebugLogOpenGL "ERR LoadStatic3DS:Not a file "+Filename$ 
  EndIf

  DebugLogOpenGL "Convert 3DS now ..."

  '--------------------- bertragen in meine Struktur !
  Local Entity:TEntity
  Local Mesh:TMesh
  Local Surface:TSurface
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Normal:TVertex=TVertex.Create(0,0,0)
  Local Texture:TTexture

  Local Mesh3DS:T3DSMesh  
  Local Vert13DS:T3DSVert  
  Local Vert23DS:T3DSVert  
  Local Vert33DS:T3DSVert  

  Entity=TEntity.Create(0,0,0)
  Self.EntityAdd Entity
  Mesh=Entity.CreateMesh()

  Local First:Int=0

  For Mesh3DS=EachIn _3DSMeshList 
   Surface=Mesh.NewSurface(GL_TRIANGLES)
   If First=0 Then First=1;Entity.Name$=Mesh3DS.MeshName$

   Local F:Int=0
   Local A:Int,B:Int,C:Int
   Local red:Double,green:Double,blue:Double

   For F=0 To Mesh3DS.NumFaces-1
    A=Mesh3DS.GetFace(F).A
    B=Mesh3DS.GetFace(F).B
    C=Mesh3DS.GetFace(F).C

    Vert13DS=Mesh3DS.GetVertex(A)
    Vert23DS=Mesh3DS.GetVertex(B)
    Vert33DS=Mesh3DS.GetVertex(C)

    Vertex1=TVertex.Create(Vert13DS.X,Vert13DS.z,-Vert13DS.y) 'fuck ! Y=Z And Z=-Y in GL <-- !
    Vertex2=TVertex.Create(Vert23DS.X,Vert23DS.z,-Vert23DS.y)
    Vertex3=TVertex.Create(Vert33DS.X,Vert33DS.z,-Vert33DS.y)

    If A<Mesh3DS.NumTex Then Vertex1.VertexTexCoords(Mesh3DS.GetTex(A).U,1.0-Mesh3DS.GetTex(A).V)
    If B<Mesh3DS.NumTex Then Vertex2.VertexTexCoords(Mesh3DS.GetTex(B).U,1.0-Mesh3DS.GetTex(B).V)
    If C<Mesh3DS.NumTex Then Vertex3.VertexTexCoords(Mesh3DS.GetTex(C).U,1.0-Mesh3DS.GetTex(C).V)

    TriangleNormal Vertex1,Vertex2,Vertex3,Normal

    Vertex1.VertexNormal(Normal.X,Normal.Y,Normal.Z)
    Vertex2.VertexNormal(Normal.X,Normal.Y,Normal.Z)
    Vertex3.VertexNormal(Normal.X,Normal.Y,Normal.Z)

    If Mesh3DS.GetFace(F).Material<>Null Then
     Surface.DIFFUSE =[Mesh3DS.GetFace(F).Material.DiffuseColour.r ,Mesh3DS.GetFace(F).Material.DiffuseColour.g ,Mesh3DS.GetFace(F).Material.DiffuseColour.b ,1.0]
     'Surface.SPECULAR=[Mesh3DS.GetFace(F).Material.SpecularColour.r,Mesh3DS.GetFace(F).Material.SpecularColour.g,Mesh3DS.GetFace(F).Material.SpecularColour.b,1.0]

     If Mesh3DS.GetFace(F).Material.TextureFile$ Then
      If Surface.Texture=Null Then
       Texture=TTexture.Load(ExtractDir(FileName$) + "\" + Mesh3DS.GetFace(F).Material.TextureFile$)
       Surface.SetTexture Texture
      EndIf
     EndIf
     red=Mesh3DS.GetFace(F).Material.DiffuseColour.r 
     green=Mesh3DS.GetFace(F).Material.DiffuseColour.g
     blue=Mesh3DS.GetFace(F).Material.DiffuseColour.b
     Vertex1.VertexColor(red,green,blue)
     Vertex2.VertexColor(red,green,blue)
     Vertex3.VertexColor(red,green,blue)
    EndIf

    Surface.AddTriangle Vertex3,Vertex2,Vertex1
   Next

  Next

  Mesh.Scale Scale,Scale,Scale
  Mesh.Compile

  '--------------------------------------------------------

  Normal=Null

  Free3DSMemory

  DebugLogOpenGL "LoadStatic3DS finish"

  Return Entity

 End Method

 '#####################################################

 Method ShowAxisOnOff(OnOff:Int)
  Local E:TEntity
  For E=EachIn Entitys
   E.ShowAxis=OnOff
  Next
 End Method

 Method SetBoundingBoxesFromMesh()
  Local E:TEntity
  For E=EachIn Entitys
   E.SetBoundingBoxFromMesh E.ShowBoundingBox
  Next
 End Method

 Method SetBoundingSpheresFromMesh()
  Local E:TEntity
  For E=EachIn Entitys
   E.SetBoundingSphereFromMesh E.ShowBoundingSphere
  Next
 End Method

 Method ShowBoundingBoxesOnOff(OnOff:Int)
  Local E:TEntity
  For E=EachIn Entitys
   E.ShowBoundingBox=OnOff
  Next
 End Method

 Method ShowBoundingSpheresOnOff(OnOff:Int)
  Local E:TEntity
  For E=EachIn Entitys
   E.ShowBoundingSphere=OnOff
  Next
 End Method

 Method SphereCollisionFlagClear(ColliType:Int=0)
  Local E:TEntity
  For E=EachIn Entitys
   If ColliType Then
    If E.ColliType=ColliType Then E.ColliSphere=0
   Else 
    E.ColliSphere=0
   EndIf
  Next
 End Method

 Method SphereCollisionTest(TypeA:Int,TypeB:Int)
  '---------------------------------------------
  'Clear the Sphere Collision List
  Local Collision:TCollision
  For Collision=EachIn EntitysSphereCollision
   Collision=Null
  Next
  EntitysSphereCollision.Clear()
  '---------------------------------------------
  Local EntityList:TList=CreateList()
  Local E:TEntity
  Local EA:TEntity
  Local EB:TEntity
  'Collect the Entitys with the Collisions Type Parameters
  For E=EachIn Entitys
   If E.ColliType=TypeA Or E.ColliType=TypeB And E.Enabled=1 Then EntityList.Addlast E;E.GetGlobalPos()
  Next
  '---------------------------------------------
  'Sphere/Sphere Intersection
  Local l:Double
  Local centerdistance:Double
  Local colli:Int
  For EA=EachIn EntityList
   For EB=EachIn EntityList
    If EA<>EB And EA.ColliType=TypeA And EB.ColliType=TypeB Then
     l=VENT(EA.GlobalPos,EB.GlobalPos) 'to do ... Global Pos
     'DebugLog "Test "+EA.NAme$+" with "+EB.Name$
     'DebugLog "l "+l
     'DebugLog "EA.BRadius "+EA.BRadius
     'DebugLog "EB.BRadius "+EB.BRadius
     centerdistance=EA.BRadius+EB.BRadius
     'DebugLog "centerdistance "+centerdistance
     colli=l<=centerdistance
     'DebugLog "colli "+colli
     If colli Then
      EA.ColliSphere=1 
      EB.ColliSphere=1 
      Collision=TCollision.Create(EA,EB)
      EntitysSphereCollision.AddLast Collision
     EndIf
    EndIf
   Next  
  Next  
  '---------------------------------------------
  EntityList=Null
 End Method

 Method RenderCollision()

  Local E:TEntity
  For E=EachIn Entitys
   E.RenderGlobalPos
  Next

 End Method

 Method SphereCollisionListDebugLog()
  Local Collision:TCollision
  For Collision=EachIn EntitysSphereCollision
   DebugLog Collision.EntityA.Name$ + " with " + Collision.EntityB.Name$
  Next
 End Method

 Method Render()
  Local E:TEntity
  For E=EachIn Entitys
   E.Render
  Next
 End Method

End Type

'##############################################################################

Type TCollision
 Field EntityA:TEntity
 Field EntityB:TEntity

 Function Create:TCollision(ColliEntityA:TEntity,ColliEntityB:TEntity)
  Local C:TCollision=New TCollision
  C.EntityA=ColliEntityA
  C.EntityB=ColliEntityB
  Return C
 End Function

 Function Free(C:TCollision Var)
  C.EntityA=Null
  C.EntityB=Null
  C=Null
 End Function

End Type

'##############################################################################

Type TIntersectTree '### not finished but works for XZ Terrain intersection ! ###

 Field BBoxT1:TV3D[21] 'Bounding Box Top
 Field BBoxT2:TV3D[21]
 Field BBoxT3:TV3D[21]
 Field BBoxT4:TV3D[21]
 Field BBoxB1:TV3D[21] 'Bounding Box Bottom
 Field BBoxB2:TV3D[21]
 Field BBoxB3:TV3D[21]
 Field BBoxB4:TV3D[21]
 Field Triangles:TList[21]

 'Tree
 '0
 '1,2,3,4
 '5,6,7,8 / 9,10,11,12 / 13,14,15,16 / 17,18,19,20

 '#########################################################

 Function Create:TIntersectTree(E:TEntity)

  DebugLog "Create:TIntersectTree for "+E.Name$

  Local I:TIntersectTree=New TIntersectTree
  Local T:Int
  'Struktur anlegen
  For T=0 To 20
   I.BBoxT1[T]=TV3D.Create() 'Bounding Box Top
   I.BBoxT2[T]=TV3D.Create()
   I.BBoxT3[T]=TV3D.Create()
   I.BBoxT4[T]=TV3D.Create()
   I.BBoxB1[T]=TV3D.Create() 'Bounding Box Bottom
   I.BBoxB2[T]=TV3D.Create()
   I.BBoxB3[T]=TV3D.Create()
   I.BBoxB4[T]=TV3D.Create()  
   I.Triangles[T]=CreateList()
  Next
  'Boxen setzen
   VCOPY E.BBoxT1,I.BBoxT1[0] 'Top
   VCOPY E.BBoxT2,I.BBoxT2[0]
   VCOPY E.BBoxT3,I.BBoxT3[0]
   VCOPY E.BBoxT4,I.BBoxT4[0]
   VCOPY E.BBoxB1,I.BBoxB1[0] 'Bottom
   VCOPY E.BBoxB2,I.BBoxB2[0]
   VCOPY E.BBoxB3,I.BBoxB3[0]
   VCOPY E.BBoxB4,I.BBoxB4[0]

  For T=1 To 4
   Select T
   Case 1
    VCOPY I.BBoxT1[0],I.BBoxT1[T] 
    VHALF I.BBoxT1[0],I.BBoxT2[0],I.BBoxT2[T]
    VHALF I.BBoxT1[0],I.BBoxT3[0],I.BBoxT3[T]
    VHALF I.BBoxT1[0],I.BBoxT4[0],I.BBoxT4[T]
   Case 2
    VHALF I.BBoxT1[0],I.BBoxT2[0],I.BBoxT1[T]
    VCOPY I.BBoxT2[0],I.BBoxT2[T] 
    VHALF I.BBoxT2[0],I.BBoxT3[0],I.BBoxT3[T]
    VHALF I.BBoxT1[0],I.BBoxT3[0],I.BBoxT4[T]
   Case 3
    VHALF I.BBoxT1[0],I.BBoxT3[0],I.BBoxT1[T]
    VHALF I.BBoxT2[0],I.BBoxT3[0],I.BBoxT2[T]
    VCOPY I.BBoxT3[0],I.BBoxT3[T] 
    VHALF I.BBoxT4[0],I.BBoxT3[0],I.BBoxT4[T]
   Case 4
    VHALF I.BBoxT1[0],I.BBoxT4[0],I.BBoxT1[T]
    VHALF I.BBoxT1[0],I.BBoxT3[0],I.BBoxT2[T]
    VHALF I.BBoxT4[0],I.BBoxT3[0],I.BBoxT3[T]
    VCOPY I.BBoxT4[0],I.BBoxT4[T] 
   End Select
  Next
  
  '5,6,7,8 

  For T=5 To 8
   Select T
   Case 5
    VCOPY I.BBoxT1[1],I.BBoxT1[T] 
    VHALF I.BBoxT1[1],I.BBoxT2[1],I.BBoxT2[T]
    VHALF I.BBoxT1[1],I.BBoxT3[1],I.BBoxT3[T]
    VHALF I.BBoxT1[1],I.BBoxT4[1],I.BBoxT4[T]
   Case 6
    VHALF I.BBoxT1[1],I.BBoxT2[1],I.BBoxT1[T]
    VCOPY I.BBoxT2[1],I.BBoxT2[T] 
    VHALF I.BBoxT2[1],I.BBoxT3[1],I.BBoxT3[T]
    VHALF I.BBoxT1[1],I.BBoxT3[1],I.BBoxT4[T]
   Case 7
    VHALF I.BBoxT1[1],I.BBoxT3[1],I.BBoxT1[T]
    VHALF I.BBoxT2[1],I.BBoxT3[1],I.BBoxT2[T]
    VCOPY I.BBoxT3[1],I.BBoxT3[T] 
    VHALF I.BBoxT4[1],I.BBoxT3[1],I.BBoxT4[T]
   Case 8
    VHALF I.BBoxT1[1],I.BBoxT4[1],I.BBoxT1[T]
    VHALF I.BBoxT1[1],I.BBoxT3[1],I.BBoxT2[T]
    VHALF I.BBoxT4[1],I.BBoxT3[1],I.BBoxT3[T]
    VCOPY I.BBoxT4[1],I.BBoxT4[T] 
   End Select
  Next

  '9,10,11,12

  For T=9 To 12
   Select T
   Case 9
    VCOPY I.BBoxT1[2],I.BBoxT1[T] 
    VHALF I.BBoxT1[2],I.BBoxT2[2],I.BBoxT2[T]
    VHALF I.BBoxT1[2],I.BBoxT3[2],I.BBoxT3[T]
    VHALF I.BBoxT1[2],I.BBoxT4[2],I.BBoxT4[T]
   Case 10
    VHALF I.BBoxT1[2],I.BBoxT2[2],I.BBoxT1[T]
    VCOPY I.BBoxT2[2],I.BBoxT2[T] 
    VHALF I.BBoxT2[2],I.BBoxT3[2],I.BBoxT3[T]
    VHALF I.BBoxT1[2],I.BBoxT3[2],I.BBoxT4[T]
   Case 11
    VHALF I.BBoxT1[2],I.BBoxT3[2],I.BBoxT1[T]
    VHALF I.BBoxT2[2],I.BBoxT3[2],I.BBoxT2[T]
    VCOPY I.BBoxT3[2],I.BBoxT3[T] 
    VHALF I.BBoxT4[2],I.BBoxT3[2],I.BBoxT4[T]
   Case 12
    VHALF I.BBoxT1[2],I.BBoxT4[2],I.BBoxT1[T]
    VHALF I.BBoxT1[2],I.BBoxT3[2],I.BBoxT2[T]
    VHALF I.BBoxT4[2],I.BBoxT3[2],I.BBoxT3[T]
    VCOPY I.BBoxT4[2],I.BBoxT4[T] 
   End Select
  Next

  '13,14,15,16

  For T=13 To 16
   Select T
   Case 13
    VCOPY I.BBoxT1[3],I.BBoxT1[T] 
    VHALF I.BBoxT1[3],I.BBoxT2[3],I.BBoxT2[T]
    VHALF I.BBoxT1[3],I.BBoxT3[3],I.BBoxT3[T]
    VHALF I.BBoxT1[3],I.BBoxT4[3],I.BBoxT4[T]
   Case 14
    VHALF I.BBoxT1[3],I.BBoxT2[3],I.BBoxT1[T]
    VCOPY I.BBoxT2[3],I.BBoxT2[T] 
    VHALF I.BBoxT2[3],I.BBoxT3[3],I.BBoxT3[T]
    VHALF I.BBoxT1[3],I.BBoxT3[3],I.BBoxT4[T]
   Case 15
    VHALF I.BBoxT1[3],I.BBoxT3[3],I.BBoxT1[T]
    VHALF I.BBoxT2[3],I.BBoxT3[3],I.BBoxT2[T]
    VCOPY I.BBoxT3[3],I.BBoxT3[T] 
    VHALF I.BBoxT4[3],I.BBoxT3[3],I.BBoxT4[T]
   Case 16
    VHALF I.BBoxT1[3],I.BBoxT4[3],I.BBoxT1[T]
    VHALF I.BBoxT1[3],I.BBoxT3[3],I.BBoxT2[T]
    VHALF I.BBoxT4[3],I.BBoxT3[3],I.BBoxT3[T]
    VCOPY I.BBoxT4[3],I.BBoxT4[T] 
   End Select
  Next

  '17,18,19,20

  For T=17 To 20
   Select T
   Case 17
    VCOPY I.BBoxT1[4],I.BBoxT1[T] 
    VHALF I.BBoxT1[4],I.BBoxT2[4],I.BBoxT2[T]
    VHALF I.BBoxT1[4],I.BBoxT3[4],I.BBoxT3[T]
    VHALF I.BBoxT1[4],I.BBoxT4[4],I.BBoxT4[T]
   Case 18
    VHALF I.BBoxT1[4],I.BBoxT2[4],I.BBoxT1[T]
    VCOPY I.BBoxT2[4],I.BBoxT2[T] 
    VHALF I.BBoxT2[4],I.BBoxT3[4],I.BBoxT3[T]
    VHALF I.BBoxT1[4],I.BBoxT3[4],I.BBoxT4[T]
   Case 19
    VHALF I.BBoxT1[4],I.BBoxT3[4],I.BBoxT1[T]
    VHALF I.BBoxT2[4],I.BBoxT3[4],I.BBoxT2[T]
    VCOPY I.BBoxT3[4],I.BBoxT3[T] 
    VHALF I.BBoxT4[4],I.BBoxT3[4],I.BBoxT4[T]
   Case 20
    VHALF I.BBoxT1[4],I.BBoxT4[4],I.BBoxT1[T]
    VHALF I.BBoxT1[4],I.BBoxT3[4],I.BBoxT2[T]
    VHALF I.BBoxT4[4],I.BBoxT3[4],I.BBoxT3[T]
    VCOPY I.BBoxT4[4],I.BBoxT4[T] 
   End Select
  Next

  'append Triangles to Bounding Boxes
  Local Mesh:TMesh
  Local Surface:TSurface
  Local Vertex:TVertex
  Local Tri:TTriangle
  Local TriangleList:TList=CreateList()
  E.GetGlobalPos()
  T=0

  If 1=1 Then 'TEST AN/AUS

  For T=5 To 20
   For Mesh=EachIn E.Meshes
    For Surface=EachIn Mesh.Surfaces
     TriangleList=Surface.GetTriangleList(E.GlobalPos.x,E.GlobalPos.y,E.GlobalPos.z)
     For Tri=EachIn TriangleList
      'only test x,z
      If I.VertexInsideBox(T,Tri.V1)=True Or I.VertexInsideBox(T,Tri.V2)=True Or I.VertexInsideBox(T,Tri.V3)=True Then
       I.Triangles[T].addlast Tri
      EndIf
     Next 'test all Triangles if inside the box
     TriangleList=Null
    Next 'surface
   Next 'mesh  
  Next 'bounding boxes

  EndIf

  Return I
 End Function

 '#########################################################

 Method VertexInsideBox:Int(TreeIndex,V:TV3D) 
  If (V.X=>BBoxT1[TreeIndex].X And V.X<=BBoxT2[TreeIndex].X) And (V.Z=>BBoxT2[TreeIndex].Z And V.Z<=BBoxT3[TreeIndex].Z) Then
   Return True
  EndIf
 End Method

 '#########################################################

 Function Free(I:TIntersectTree Var)
  Local T:Int
  For T=0 To 20
   I.BBoxT1[T]=Null 
   I.BBoxT2[T]=Null
   I.BBoxT3[T]=Null
   I.BBoxT4[T]=Null
   I.BBoxB1[T]=Null
   I.BBoxB2[T]=Null
   I.BBoxB3[T]=Null
   I.BBoxB4[T]=Null
  Next
  Local Tri:TTriangle
  For T=0 To 20
   For Tri=EachIn I.Triangles[T]
    TTriangle.Free Tri
   Next
   I.Triangles[T]=Null
  Next

  I=Null
 End Function

 '#########################################################

 Method Render()

  Local L:Int
  Local B:Int

	   l=glIsEnabled(GL_LIGHTING)
	   If l Then glDisable GL_LIGHTING
       glPushMatrix()

       glBegin( GL_LINES )
       glColor3d( 1.0, 1.0, 0.0 ) 'yellow

       For B=5 To 20

        glVertex3d(BBoxT1[B].x,BBoxT1[B].y,BBoxT1[B].z);  glVertex3d(BBoxT2[B].x,BBoxT2[B].y,BBoxT2[B].z) 'oben
        glVertex3d(BBoxT2[B].x,BBoxT2[B].y,BBoxT2[B].z);  glVertex3d(BBoxT3[B].x,BBoxT3[B].y,BBoxT3[B].z)
        glVertex3d(BBoxT3[B].x,BBoxT3[B].y,BBoxT3[B].z);  glVertex3d(BBoxT4[B].x,BBoxT4[B].y,BBoxT4[B].z)
        glVertex3d(BBoxT4[B].x,BBoxT4[B].y,BBoxT4[B].z);  glVertex3d(BBoxT1[B].x,BBoxT1[B].y,BBoxT1[B].z)

        'glVertex3d(BBoxB1.x,BBoxB1.y,BBoxB1.z);  glVertex3d(BBoxB2.x,BBoxB2.y,BBoxB2.z) 'unten
        'glVertex3d(BBoxB2.x,BBoxB2.y,BBoxB2.z);  glVertex3d(BBoxB3.x,BBoxB3.y,BBoxB3.z)
        'glVertex3d(BBoxB3.x,BBoxB3.y,BBoxB3.z);  glVertex3d(BBoxB4.x,BBoxB4.y,BBoxB4.z)
        'glVertex3d(BBoxB4.x,BBoxB4.y,BBoxB4.z);  glVertex3d(BBoxB1.x,BBoxB1.y,BBoxB1.z)

        'glVertex3d(BBoxT1.x,BBoxT1.y,BBoxT1.z);  glVertex3d(BBoxB1.x,BBoxB1.y,BBoxB1.z) 'oben-unten
        'glVertex3d(BBoxT2.x,BBoxT2.y,BBoxT2.z);  glVertex3d(BBoxB2.x,BBoxB2.y,BBoxB2.z)
        'glVertex3d(BBoxT3.x,BBoxT3.y,BBoxT3.z);  glVertex3d(BBoxB3.x,BBoxB3.y,BBoxB3.z)
        'glVertex3d(BBoxT4.x,BBoxT4.y,BBoxT4.z);  glVertex3d(BBoxB4.x,BBoxB4.y,BBoxB4.z)

       Next

       glEnd()

       glPopMatrix()

	   If l Then glEnable GL_LIGHTING

 End Method

 '#########################################################

 Method RayIntersect:Int(P:TV3D, D:TV3D, T:TV3D,L:Double, CullBackfaces:Int=False)

  Local Intersect:Int
  Local IntersectQ:Int
  Local TreeIndex=0
  Local TreeIndex2=0
  Local Tri:TTriangle
  Local A:Int
  Local B:Int

  '-------------------------------
  '... find Tree 
  '2 Intersections per Plane (Box) , if True then Interect this Triangle List
  'T1,T2,T3 and T1,T3,T4 from TOP
  For TreeIndex=1 To 4

   IntersectQ=RayIntersectTriangle(P,D,T,BBoxT1[TreeIndex],BBoxT2[TreeIndex],BBoxT3[TreeIndex],L,CullBackfaces)
   If IntersectQ=0 Then IntersectQ=RayIntersectTriangle(P,D,T,BBoxT1[TreeIndex],BBoxT3[TreeIndex],BBoxT4[TreeIndex],L,CullBackfaces)

   If IntersectQ Then
    '5,6,7,8 / 9,10,11,12 / 13,14,15,16 / 17,18,19,20
    Select TreeIndex
    Case 1;A= 5;B= 8
    Case 2;A= 9;B=12
    Case 3;A=13;B=16
    Case 4;A=17;B=20
    End Select
    For TreeIndex2=A To B
     IntersectQ=RayIntersectTriangle(P,D,T,BBoxT1[TreeIndex2],BBoxT2[TreeIndex2],BBoxT3[TreeIndex2],L,CullBackfaces)
     If IntersectQ=0 Then IntersectQ=RayIntersectTriangle(P,D,T,BBoxT1[TreeIndex2],BBoxT3[TreeIndex2],BBoxT4[TreeIndex2],L,CullBackfaces)
     If IntersectQ Then
      For Tri=EachIn Triangles[TreeIndex2]
       Intersect=RayIntersectTriangle(P,D,T,Tri.V1,Tri.V2,Tri.V3,L,CullBackfaces)
       If Intersect Then Exit
      Next
     EndIf 'intersect Plane A-B
     If Intersect Then Exit
    Next

   EndIf 'intersect Plane 1-4

   If Intersect Then Exit
  Next 'Tree 1-4

  Return Intersect

 End Method

 '#########################################################

 Method RayIntersectTriangle:Int(P:TV3D, D:TV3D, T:TV3D, V0:TV3D, V1:TV3D, V2:TV3D,L:Double, CullBackfaces:Int=False)

  'Sub Routine for RayIntersect

  'P = Position
  'D = Direction
  'L = Length

  'E1 E2 = Edge
  Local E1x:Double 
  Local E1y:Double
  Local E1z:Double

  Local E2x:Double
  Local E2y:Double
  Local E2z:Double

  Local Hx:Double
  Local Hy:Double
  Local Hz:Double

  Local A:Double
  Local F:Double

  Local Sx:Double
  Local Sy:Double
  Local Sz:Double

  Local U:Double,V:Double

  Local Qx:Double
  Local Qy:Double
  Local Qz:Double

  Local Ti:Double
 	
	E1x = V2.x - V0.x
	E1y = V2.y - V0.y
	E1z = V2.z - V0.z

	E2x = V1.x - V0.x
	E2y = V1.y - V0.y
	E2z = V1.z - V0.z

	Hx = (D.y * E2z) - (E2y * D.z)
	Hy = (D.z * E2x) - (E2z * D.x)
	Hz = (D.x * E2y) - (E2x * D.y)

	A = (E1x * Hx) + (E1y * Hy) + (E1z * Hz)

	If (CullBackfaces = True) And (A >= 0) Then Return False
		
	If (A > -0.00001) And (A < 0.00001) Then Return False 
	
	F = 1.0 / A

	Sx = P.x - V0.x
	Sy = P.y - V0.y
	Sz = P.z - V0.z
	
	U = F * ((Sx * Hx) + (Sy * Hy) + (Sz * Hz))
	
	If (U < 0.0) Or (U > 1.0) Then Return False

	Qx = (Sy * E1z) - (E1y * Sz)
	Qy = (Sz * E1x) - (E1z * Sx)
	Qz = (Sx * E1y) - (E1x * Sy)
	
	V = F * ((D.x * Qx) + (D.y * Qy) + (D.z * Qz))
	
	If (V < 0.0) Or ((U + V) > 1.0) Then	Return False

	Ti = F * ((E2x * Qx) + (E2y * Qy) + (E2z * Qz)) 't=tiefe vom Startpunkt zur Flche

    If Ti<0.0 Then Return 0
    If Ti>L   Then Return 0 'Geht ber die Lnge hinaus

    T.x=P.x+Ti*D.x
    T.y=P.y+Ti*D.y
    T.z=P.z+Ti*D.z

   'IntersectInfo.U=U
   'IntersectInfo.V=V
   'IntersectInfo.T=T

  Return True 'Intersect :-)

 End Method

End Type

'##############################################################################

Type TEntity
 Field Parent:TEntity
 Field Name:String
 Field ColliType:Int
 Field ColliSphere:Int
 Field ColliBox:Int
 Field Pos:TV3D
 Field GlobalPos:TV3D
 Field Meshes:TList
 Field Enabled:Int
 Field AchseX:TV3D
 Field AchseY:TV3D
 Field AchseZ:TV3D
 Field ShowAxis:Int

 Field BBoxT1:TV3D 'Bounding Box Top
 Field BBoxT2:TV3D
 Field BBoxT3:TV3D
 Field BBoxT4:TV3D
 Field BBoxB1:TV3D 'Bounding Box Bottom
 Field BBoxB2:TV3D
 Field BBoxB3:TV3D
 Field BBoxB4:TV3D
 Field ShowBoundingBox:Int

 Field BRadius:Double
 Field ShowBoundingSphere:Int

 Field IntersectTree:TIntersectTree 

 Field IDA:Int '3DS Hirachy
 Field IDB:Int '3DS Hirachy

 'Field MODELVIEWMATRIX:TMatrix

 Function Create:TEntity(x:Double=0,y:Double=0,z:Double=0,Parent:TEntity=Null)
  DebugLogOpenGL "Create Entity" 
  Local e:TEntity=New TEntity

  e.Parent=Parent
  e.Name$="NoName"

  e.ColliType=0
  e.ColliSphere=0
  e.ColliBox=0

  e.AchseX=TV3D.Create(1,0,0)
  e.AchseY=TV3D.Create(0,1,0)
  e.AchseZ=TV3D.Create(0,0,1)
  e.ShowAxis=0

  e.Pos=TV3D.Create(x,y,z)
  e.GlobalPos=TV3D.Create(0,0,0)

  e.BBoxT1=TV3D.Create() 'Bounding Box Top
  e.BBoxT2=TV3D.Create()
  e.BBoxT3=TV3D.Create()
  e.BBoxT4=TV3D.Create()
  e.BBoxB1=TV3D.Create() 'Bounding Box Bottom
  e.BBoxB2=TV3D.Create()
  e.BBoxB3=TV3D.Create()
  e.BBoxB4=TV3D.Create()  
  e.SetBoundingBox 1,1,1,0

  e.SetBoundingSphere 1,0

  e.Meshes=CreateList()
  e.Enabled=1
  Return e
 End Function

 Function Free(E:TEntity Var)
  Local M:TMesh
  For M=EachIn E.Meshes
    TMesh.Free M
  Next
  E.Meshes=Null
  E.Pos=Null
  E.GlobalPos=Null
  E.Parent=Null
  E.AchseX=Null
  E.AchseY=Null
  E.AchseZ=Null
  E.BBoxT1=Null
  E.BBoxT2=Null
  E.BBoxT3=Null
  E.BBoxT4=Null
  E.BBoxB1=Null
  E.BBoxB2=Null
  E.BBoxB3=Null
  E.BBoxB4=Null

  If E.IntersectTree<>Null Then TIntersectTree.Free E.IntersectTree
  E=Null
 End Function

 Method CreateMesh:TMesh()
  Local Mesh:TMesh=TMesh.Create()
  Self.AddMesh Mesh
  Return Mesh
 End Method

 Method SetBoundingSphere(Radius:Double=1,Visible:Int=0)
  BRadius=Radius
  ShowBoundingSphere=Visible 
 End Method

 Method SetBoundingSphereFromMesh(Visible:Int=0)

  Local mx:Double=0.0,my:Double=0.0,mz:Double=0.0

  Local Mesh:TMesh
  Local Surface:TSurface
  Local V:TVertex
  For Mesh=EachIn Meshes
   For Surface=EachIn Mesh.Surfaces
    For V=EachIn Surface.Vertices
     If Abs(V.X)>mx Then mx=Abs(V.X)
     If Abs(V.Y)>my Then my=Abs(V.Y)
     If Abs(V.Z)>mz Then mz=Abs(V.Z)
    Next
   Next
  Next	

  BRadius=Sqr(mx*mx + my*my + mz*mz) 'lenght of Vector
  ShowBoundingSphere=Visible

 End Method

 Method SetBoundingBox(width:Double=1,height:Double=1,depth:Double=1,Visible:Int=0)
  width=width/2.0
  height=height/2.0
  depth=depth/2.0
  BBoxT1.Set -width,height,-depth 'oben
  BBoxT2.Set  width,height,-depth 
  BBoxT3.Set  width,height, depth
  BBoxT4.Set -width,height, depth
  BBoxB1.Set -width,-height,-depth 'unten
  BBoxB2.Set  width,-height,-depth
  BBoxB3.Set  width,-height, depth
  BBoxB4.Set -width,-height, depth
  ShowBoundingBox=Visible 
 End Method

 Method SetBoundingBoxFromMesh(Visible:Int=0)

  Local mx1:Double= 3.4*10^38,my1:Double= 3.4*10^38,mz1:Double= 3.4*10^38
  Local mx2:Double=-3.4*10^38,my2:Double=-3.4*10^38,mz2:Double=-3.4*10^38
  Local check=False

  Local Mesh:TMesh
  Local Surface:TSurface
  Local V:TVertex
  For Mesh=EachIn Meshes
   For Surface=EachIn Mesh.Surfaces
    For V=EachIn Surface.Vertices
     If V.X<mx1 Then mx1=V.X
     If V.Y<my1 Then my1=V.Y
     If V.Z<mz1 Then mz1=V.Z
     If V.X>mx2 Then mx2=V.X
     If V.Y>my2 Then my2=V.Y
     If V.Z>mz2 Then mz2=V.Z
     check=True
    Next
   Next
  Next	

  If check=True Then
   BBoxT1.Set mx1,my2,mz1 'oben
   BBoxT2.Set mx2,my2,mz1 
   BBoxT3.Set mx2,my2,mz2
   BBoxT4.Set mx1,my2,mz2
   BBoxB1.Set mx1,my1,mz1 'unten
   BBoxB2.Set mx2,my1,mz1
   BBoxB3.Set mx2,my1,mz2
   BBoxB4.Set mx1,my1,mz2
   ShowBoundingBox=Visible
  Else
   SetBoundingBox 0,0,0,0
  EndIf 
 End Method

 Method AddMesh(M:TMesh)
  Meshes.addlast M
 End Method

 Method Position(px:Double,py:Double,pz:Double)
  Pos.Set (px,py,pz)
 End Method

 Method PositionLimitX(x_Left,x_right)
  If Pos.x<x_left  Then Pos.x=x_left '-x
  If Pos.x>x_right Then Pos.x=x_right'+x
 End Method

 Method PositionLimitY(y_down,y_up)
  If Pos.y<y_down Then Pos.y=y_down'-y
  If Pos.y>y_up   Then Pos.y=y_up  '+y
 End Method

 Method PositionLimitZ(z_from,z_to)
  If Pos.z<z_to   Then Pos.z=z_to   '-z
  If Pos.z>z_from Then Pos.z=z_from '+z
 End Method

 Method Move(mx:Double,my:Double,mz:Double) 
 
   Local M:TMatrix
   Local MP:TMatrix
   Local MT:TMatrix
   M:TMatrix=TMatrix.Create()
   MP:TMatrix=TMatrix.Create() 
   MT:TMatrix=TMatrix.Create()

   MatrixCreateIdentity MP
   MatrixEntity Self,MT
   MatrixMultiply MT,MP,M	

   'Transform
   Pos.x=Pos.x + mx * M.A[0, 0] + my * M.A[1, 0] + mz * M.A[2, 0]
   Pos.y=Pos.y + mx * M.A[0, 1] + my * M.A[1, 1] + mz * M.A[2, 1]
   Pos.z=Pos.z + mx * M.A[0, 2] + my * M.A[1, 2] + mz * M.A[2, 2]

   M=Null
   MP=Null
   MT=Null

 End Method

 Method AxisDebugLog()
  DebugLog Name$
  DebugLog "X Axis "+AchseX.X+","+AchseX.Y+","+AchseX.Z
  DebugLog "Y Axis "+AchseY.X+","+AchseY.Y+","+AchseY.Z
  DebugLog "Z Axis "+AchseZ.X+","+AchseZ.Y+","+AchseZ.Z
 End Method

 Method Rotate(RotX:Double,RotY:Double,RotZ:Double)
  AchseX.Set(1,0,0)
  AchseY.Set(0,1,0)
  AchseZ.Set(0,0,1)
  Turn RotX,RotY,RotZ
 End Method

 Method Turn(x:Double,y:Double,z:Double) 

  'Geile Sache :-)

  'Auf den XYZ Achsen das Object drehen !

  'Siehe auch Entity.Create

  Local M:TMatrix=TMatrix.Create()
  Local A:TV3D=TV3D.Create()
  If X Then 
   A.Set(1,0,0)
   MatrixCreateAxisRotate(A,X,M)
   VTrans AchseX,M
   VTrans AchseY,M
   VTrans AchseZ,M
  EndIf
  If Y Then
   A.Set(0,1,0)
   MatrixCreateAxisRotate(A,Y,M)
   VTrans AchseX,M
   VTrans AchseY,M
   VTrans AchseZ,M
  EndIf
  If Z Then 
   A.Set(0,0,1)
   MatrixCreateAxisRotate(A,Z,M)
   VTrans AchseX,M
   VTrans AchseY,M
   VTrans AchseZ,M
  EndIf
  M=Null
  A=Null

 End Method

 Method SetMeshesVertexColor(Red:Double,Green:Double,Blue:Double,Alpha:Double=1.0)
  Local Mesh:TMesh
  For Mesh=EachIn Meshes
   If Mesh.Compiled Then
    Mesh.NoCompile
    Mesh.SetVertexColor Red,Green,Blue,Alpha
    Mesh.Compile
   Else
    Mesh.SetVertexColor Red,Green,Blue,Alpha
   EndIf
  Next	
 End Method

 Method SetMeshesDiffuseColor(Red:Double,Green:Double,Blue:Double,Alpha:Double=1.0)
  Local Mesh:TMesh
  For Mesh=EachIn Meshes
   If Mesh.Compiled Then
    Mesh.NoCompile
    Mesh.SetDiffuseColor Red,Green,Blue,Alpha
    Mesh.Compile
   Else
    Mesh.SetDiffuseColor Red,Green,Blue,Alpha
   EndIf
  Next	
 End Method

 Method SetMeshesFaces(Front:Int=1,Back:Int=1)
  Local Mesh:TMesh
  For Mesh=EachIn Meshes
   If Mesh.Compiled Then
    Mesh.NoCompile
    Mesh.SetFaces Front,Back
    Mesh.Compile
   Else
    Mesh.SetFaces Front,Back
   EndIf
  Next	
 End Method

 Method Translate(tx:Double,ty:Double,tz:Double)
  
  'with Help from Dremora

   Local T:TV3D=TV3D.Create(tx,ty,tz)
   Local A:TV3D=TV3D.Create()
   Local MA:TMatrix
   Local MB:TMatrix
   Local MC:TMatrix

   MA:TMatrix=TMatrix.Create()
   MB:TMatrix=TMatrix.Create() 
   MC:TMatrix=TMatrix.Create()

   If Self.Parent Then
     'DebugLog "Self "+Self.Name$
     'DebugLog "Self.Parent "+Self.Parent.Name$

    MatrixCreateIdentity MA

		Local TransformList:TList, Entity:TEntity
		
		' Hierarchically Transformation
		If Self.Parent Then
			TransformList = CreateList()
			Entity = Self.Parent
			While Entity <> Null
			    TransformList.Addfirst(Entity)
				Entity = Entity.Parent
			Wend
			'TransformList.Reverse()		
			For Entity = EachIn TransformList
             MatrixEntity Entity,MB
 	         MatrixMultiply MA,MB,MC	
			 MatrixCopy MC,MA	
			Next
			TransformList=Null
		EndIf
      MatrixEntity Self,MB
      MatrixMultiply MA,MB,MC
 	  MatrixCopy MC,MA	

    VTrans2 T,MA
    VAdd Pos,T,Pos

   Else
    VAdd Pos,T,Pos
   EndIf

   T=Null
   MA=Null
   MB=Null
   MC=Null

 End Method

 Method GetGlobalPos:TV3D()
  
   Local MA:TMatrix
   Local MB:TMatrix
   Local MC:TMatrix

   MA:TMatrix=TMatrix.Create()
   MB:TMatrix=TMatrix.Create() 
   MC:TMatrix=TMatrix.Create()

   If Self.Parent Then

    MatrixCreateIdentity MA

		Local TransformList:TList, Entity:TEntity
		
		' Hierarchically Transformation
		If Self.Parent Then
			TransformList = CreateList()
			Entity = Self.Parent
			While Entity <> Null
			    TransformList.Addfirst(Entity)
				Entity = Entity.Parent
			Wend
			'TransformList.Reverse()		
			For Entity = EachIn TransformList
             MatrixEntity Entity,MB
 	         MatrixMultiply MB,MA,MC	
			 MatrixCopy MC,MA	
			Next
			TransformList=Null
		EndIf
      MatrixEntity Self,MB
      MatrixMultiply MB,MA,MC
 	  MatrixCopy MC,MA	

     GlobalPos.X=MA.A[3, 0]
	 GlobalPos.Y=MA.A[3, 1]
	 GlobalPos.Z=MA.A[3, 2]

   Else
     VCOPY Pos,GlobalPos
   EndIf

   MA=Null
   MB=Null
   MC=Null

   Return GlobalPos

 End Method

 Method RayIntersectMeshes:Int(P:TV3D,D:TV3D,T:TV3D Var,L:Double,CullBackfaces:Int=0)

  'MR 28.08.2005

  'only for Meshes with Triangles and non rotated Entitys !!!

  'P = Position Start
  'D = Direction Ray
  'T = Target
  'L = Lenght

  Self.GetGlobalPos()

  Local Mesh:TMesh
  Local Surface:TSurface
  Local Vertex:TVertex
  Local v0:TV3D=TV3D.Create()
  Local v1:TV3D=TV3D.Create()
  Local v2:TV3D=TV3D.Create()
  Local v3:TV3D=TV3D.Create()

  Local Intersected:Int
  Local c:Int=0

	For Mesh =EachIn Meshes
		For Surface =EachIn Mesh.Surfaces
         '----------------------------------------------------------------------------------
 	     If Surface.SurfaceTyp=GL_TRIANGLES Then
			For Vertex = EachIn Surface.Vertices
			 c=c+1
			 Select c
			 Case 1;v0.Set(Vertex.x,Vertex.y,Vertex.z);VADD v0,Self.GlobalPos,v0
			 Case 2;v1.Set(Vertex.x,Vertex.y,Vertex.z);VADD v1,Self.GlobalPos,v1
			 Case 3;v2.Set(Vertex.x,Vertex.y,Vertex.z);VADD v2,Self.GlobalPos,v2
			 End Select	
			 If c=3 Then
			    c=0		
				Intersected = Self.RayIntersectTriangle(P, D, T, v0,v1,v2, L, CullBackfaces)
		     EndIf 'one Triangle
             If Intersected Then Exit
			Next 'Vertices
	     ElseIf Surface.SurfaceTyp=GL_QUADS Then
			For Vertex = EachIn Surface.Vertices
			 c=c+1
			 Select c
			 Case 1;v0.Set(Vertex.x,Vertex.y,Vertex.z);VADD v0,Self.GlobalPos,v0
			 Case 2;v1.Set(Vertex.x,Vertex.y,Vertex.z);VADD v1,Self.GlobalPos,v1
			 Case 3;v2.Set(Vertex.x,Vertex.y,Vertex.z);VADD v2,Self.GlobalPos,v2
			 Case 4;v3.Set(Vertex.x,Vertex.y,Vertex.z);VADD v3,Self.GlobalPos,v3
			 End Select	
			 If c=4 Then
			    c=0		
				Intersected = Self.RayIntersectTriangle(P, D, T, v0,v1,v2, L, CullBackfaces)
				If Intersected=0 Then Intersected = Self.RayIntersectTriangle(P, D, T, v0,v2,v3, L, CullBackfaces)
		     EndIf 'one Triangle
             If Intersected Then Exit
			Next 'Vertices
	     EndIf
         '----------------------------------------------------------------------------------
         '----------------------------------------------------------------------------------
         If Intersected Then Exit
		Next 'Surfaces
        If Intersected Then Exit
	Next 'Meshes

    If Intersected Then
     '... fill Intersection Info 
	EndIf 

    v0=Null
    v1=Null
    v2=Null
    v3=Null
	Return Intersected

 End Method

 Method RayIntersectTriangle:Int(P:TV3D, D:TV3D, T:TV3D, V0:TV3D, V1:TV3D, V2:TV3D,L:Double, CullBackfaces:Int=False)
 
  'P = Position
  'D = Direction
  'L = Length

  'E1 E2 = Edge
  Local E1x:Double 
  Local E1y:Double
  Local E1z:Double

  Local E2x:Double
  Local E2y:Double
  Local E2z:Double

  Local Hx:Double
  Local Hy:Double
  Local Hz:Double

  Local A:Double
  Local F:Double

  Local Sx:Double
  Local Sy:Double
  Local Sz:Double

  Local U:Double,V:Double

  Local Qx:Double
  Local Qy:Double
  Local Qz:Double

  Local Ti:Double
	
	E1x = V2.x - V0.x
	E1y = V2.y - V0.y
	E1z = V2.z - V0.z

	E2x = V1.x - V0.x
	E2y = V1.y - V0.y
	E2z = V1.z - V0.z

	Hx = (D.y * E2z) - (E2y * D.z)
	Hy = (D.z * E2x) - (E2z * D.x)
	Hz = (D.x * E2y) - (E2x * D.y)

	A = (E1x * Hx) + (E1y * Hy) + (E1z * Hz)

	If (CullBackfaces = True) And (A >= 0) Then Return False
		
	If (A > -0.00001) And (A < 0.00001) Then Return False 
	
	F = 1.0 / A

	Sx = P.x - V0.x
	Sy = P.y - V0.y
	Sz = P.z - V0.z
	
	U = F * ((Sx * Hx) + (Sy * Hy) + (Sz * Hz))
	
	If (U < 0.0) Or (U > 1.0) Then Return False

	Qx = (Sy * E1z) - (E1y * Sz)
	Qy = (Sz * E1x) - (E1z * Sx)
	Qz = (Sx * E1y) - (E1x * Sy)
	
	V = F * ((D.x * Qx) + (D.y * Qy) + (D.z * Qz))
	
	If (V < 0.0) Or ((U + V) > 1.0) Then	Return False

	Ti = F * ((E2x * Qx) + (E2y * Qy) + (E2z * Qz)) 't=tiefe vom Startpunkt zur Flche

    If Ti<0.0 Then Return 0
    If Ti>L   Then Return 0 'Geht ber die Lnge hinaus

    T.x=P.x+Ti*D.x
    T.y=P.y+Ti*D.y
    T.z=P.z+Ti*D.z

   'IntersectInfo.U=U
   'IntersectInfo.V=V
   'IntersectInfo.T=T

  Return True 'Intersect :-)

 End Method

 Method RenderGlobalPos()

  'Dient nur zur Hilfe

  glPushMatrix()

  glTranslated GlobalPos.X,GlobalPos.Y,GlobalPos.Z

  Local l:Int
      '----------------------------------
	  If ShowBoundingSphere Then
	   l=glIsEnabled(GL_LIGHTING)
	   If l Then glDisable GL_LIGHTING
       glBegin( GL_LINES ) 
        glColor3d( 0.0, 0.0, 1.0 ) 'blue
        glVertex3d( 0.0,-BRadius, 0.0 );  glVertex3d(0,BRadius,0)
       glEnd()
	   If l Then glEnable GL_LIGHTING
	  EndIf
      '----------------------------------

   glPopMatrix()

 End Method

 Method Render()
  If Enabled Then
   Local M:TMatrix
   Local MP:TMatrix
   Local MT:TMatrix
   M:TMatrix=TMatrix.Create() 
   MP:TMatrix=TMatrix.Create() 
   MT:TMatrix=TMatrix.Create()

   glPushMatrix()
   glGetDoublev(GL_MODELVIEW_MATRIX,MP.A)

      '---------------------------------- 
		Local TransformList:TList, Entity:TEntity
		
		' Hierarchically Transformation
		If Self.Parent Then
			TransformList = CreateList()
			Entity = Self.Parent
			While Entity <> Null
				TransformList.Addfirst(Entity)
				Entity = Entity.Parent
			Wend
			'TransformList.Reverse()		
			For Entity = EachIn TransformList
             MatrixEntity Entity,MT
 	         MatrixMultiply MT,MP,M	
			 MatrixCopy M,MP
			Next
			TransformList=Null
		EndIf
		
      '----------------------------------
      MatrixEntity Self,MT
      MatrixMultiply MT,MP,M
            
	  glLoadMatrixd M.A 'berschreib die aktuelle !
	
	  Local Mesh:TMesh
	  For Mesh=EachIn Meshes
	   Mesh.Render
	  Next	

      '----------------------------------
      Local l:Int
	  If ShowAxis Then
	   l=glIsEnabled(GL_LIGHTING)
	   If l Then glDisable GL_LIGHTING
       glPushMatrix()
	   glScaled( 5, 5, 5 )
       glBegin( GL_LINES ) 
       
	   If Parent Then
        glColor3d( 1.0, 0.0, 0.0 ) 'red
        glVertex3d( 0.0, 0.0, 0.0 );  glVertex3d( AchseX.X,AchseX.Y,AchseX.Z )'X axis

        glColor3d( 0.0, 1.0, 0.0 ) 'green
        glVertex3d( 0.0, 0.0, 0.0 );  glVertex3d( AchseY.X,AchseY.Y,AchseY.Z )'Y axis

        glColor3d( 0.0, 0.0, 1.0 ) 'blue
        glVertex3d( 0.0, 0.0, 0.0 );  glVertex3d( AchseZ.X,AchseZ.Y,AchseZ.Z )'Z axis
       Else
        'because we have loaded this Matrix (first Entity)
        glColor3d( 1.0, 0.0, 0.0 ) 'red
        glVertex3d( 0.0, 0.0, 0.0 );  glVertex3d(1,0,0)'X axis

        glColor3d( 0.0, 1.0, 0.0 ) 'green
        glVertex3d( 0.0, 0.0, 0.0 );  glVertex3d(0,1,0)'Y axis

        glColor3d( 0.0, 0.0, 1.0 ) 'blue
        glVertex3d( 0.0, 0.0, 0.0 );  glVertex3d(0,0,1)'Z axis
       EndIf
       glEnd()
       glPopMatrix()
	   If l Then glEnable GL_LIGHTING
	  EndIf
      '----------------------------------
	  If ShowBoundingBox Then
	   l=glIsEnabled(GL_LIGHTING)
	   If l Then glDisable GL_LIGHTING
       glPushMatrix()
       glBegin( GL_LINES )
       glColor3d( 1.0, 1.0, 0.0 ) 'yellow
       glVertex3d(BBoxT1.x,BBoxT1.y,BBoxT1.z);  glVertex3d(BBoxT2.x,BBoxT2.y,BBoxT2.z) 'oben
       glVertex3d(BBoxT2.x,BBoxT2.y,BBoxT2.z);  glVertex3d(BBoxT3.x,BBoxT3.y,BBoxT3.z)
       glVertex3d(BBoxT3.x,BBoxT3.y,BBoxT3.z);  glVertex3d(BBoxT4.x,BBoxT4.y,BBoxT4.z)
       glVertex3d(BBoxT4.x,BBoxT4.y,BBoxT4.z);  glVertex3d(BBoxT1.x,BBoxT1.y,BBoxT1.z)

       glVertex3d(BBoxB1.x,BBoxB1.y,BBoxB1.z);  glVertex3d(BBoxB2.x,BBoxB2.y,BBoxB2.z) 'unten
       glVertex3d(BBoxB2.x,BBoxB2.y,BBoxB2.z);  glVertex3d(BBoxB3.x,BBoxB3.y,BBoxB3.z)
       glVertex3d(BBoxB3.x,BBoxB3.y,BBoxB3.z);  glVertex3d(BBoxB4.x,BBoxB4.y,BBoxB4.z)
       glVertex3d(BBoxB4.x,BBoxB4.y,BBoxB4.z);  glVertex3d(BBoxB1.x,BBoxB1.y,BBoxB1.z)

       glVertex3d(BBoxT1.x,BBoxT1.y,BBoxT1.z);  glVertex3d(BBoxB1.x,BBoxB1.y,BBoxB1.z) 'oben-unten
       glVertex3d(BBoxT2.x,BBoxT2.y,BBoxT2.z);  glVertex3d(BBoxB2.x,BBoxB2.y,BBoxB2.z)
       glVertex3d(BBoxT3.x,BBoxT3.y,BBoxT3.z);  glVertex3d(BBoxB3.x,BBoxB3.y,BBoxB3.z)
       glVertex3d(BBoxT4.x,BBoxT4.y,BBoxT4.z);  glVertex3d(BBoxB4.x,BBoxB4.y,BBoxB4.z)

       glEnd()
       glPopMatrix()
	   If l Then glEnable GL_LIGHTING
	  EndIf
      '----------------------------------
	  If ShowBoundingSphere Then 
	   l=glIsEnabled(GL_LIGHTING)
	   If l Then glDisable GL_LIGHTING
       glPushMatrix()      
       Local qobj:Byte Ptr 'MR 04.06.2006
       qobj=gluNewQuadric() 'http://www.fh-landshut.de/~gschied/opengl/09-tesselators-mdoerschmidt/node24.html
       If qobj Then
        gluQuadricDrawStyle qobj,GLU_LINE
		If ColliSphere Then glColor3d( 1.0, 0.0, 0.0 ) Else glColor3d( 1.0, 1.0, 0.0 ) 'red=colli , yellow=no collision
        gluSphere qobj,BRadius,9,9
        gluDeleteQuadric qobj
       EndIf
       glPopMatrix()
	   If l Then glEnable GL_LIGHTING
	  EndIf
      '----------------------------------
	
     glPopMatrix()

   M=Null
   MP=Null 
   MT=Null 
  EndIf 'Enabled
 End Method
 
End Type

'##############################################################################

Type TTexture

 Field File$
 Field Handle:Int
 Field ScaleU:Double
 Field ScaleV:Double
 Field PosU:Double
 Field PosV:Double
 Field Rotation:Double
 Field UseMask:Int
 Field Width:Int
 Field Height:Int
 Field ClampU:Int
 Field ClampV:Int

 Function CreateFromPixmap:TTexture(Pixmap:TPixmap,maskred:Int=-1,maskgreen:Int=-1,maskblue:Int=-1)

  'DebugLog "TTexture.CreateFromPixmap "+Pixmap.width+" x "+Pixmap.height 

  Local T:TTexture=New TTexture
  T.File$=""
  T.ScaleU=1.0
  T.ScaleV=1.0
  T.PosU=0.0
  T.PosV=0.0
  T.ClampU=0
  T.ClampV=0
  T.Rotation=0.0
  'glGetIntegerv(GL_MAX_TEXTURE_SIZE, &texSize);
  '... resize wenn zu gro ...
  '---------------------- Mask 
  If maskred=>0 And maskgreen=>0 And maskblue=>0 Then
   T.UseMask=True
   Pixmap=MaskPixmap(Pixmap,maskred,maskgreen,maskblue) 
  Else
   T.UseMask=False
  EndIf
  '----------------------
  T.Width=Pixmap.Width
  T.Height=Pixmap.Height

  T.Handle=GLTexFromPixmap(Pixmap)',False) 'bglTexFromPixmap(Pixmap) 'mit MipMap war alles wei ...
  Pixmap=Null '; FlushMem
  Return T
 End Function

 Function Create:TTexture(width:Int,height:Int,maskred:Int=-1,maskgreen:Int=-1,maskblue:Int=-1)

  DebugLogOpenGL "TTexture.Create "+width+" x "+height 

  Local T:TTexture=New TTexture
  T.File$=""
  T.ScaleU=1.0
  T.ScaleV=1.0
  T.PosU=0.0
  T.PosV=0.0
  T.ClampU=0
  T.ClampV=0
  T.Rotation=0.0
  Local pm:TPixmap=CreatePixmap(width,height,PF_RGB888)
  'glGetIntegerv(GL_MAX_TEXTURE_SIZE, &texSize);
  '... resize wenn zu gro ...
  '---------------------- Mask 
  If maskred=>0 And maskgreen=>0 And maskblue=>0 Then
   T.UseMask=True
   pm=MaskPixmap(pm,maskred,maskgreen,maskblue) 
  Else
   T.UseMask=False
  EndIf
  '----------------------
  T.Width=pm.Width
  T.Height=pm.Height

  T.Handle=GLTexFromPixmap(pm)',False) ' bglTexFromPixmap(pm) 'mit MipMap war alles wei ...
  pm=Null '; FlushMem
  Return T
 End Function

 Function Free(T:TTexture Var)
  TextureList.Remove T
  If T.Handle Then glDeleteTextures 1,Varptr(T.Handle) '???
  T=Null
 End Function

 Method UpdateFromPixmap(Pixmap:TPixmap)
  If Handle Then glDeleteTextures 1,Varptr(Handle) '???
  Width=Pixmap.Width
  Height=Pixmap.Height
  Handle=GLTexFromPixmap(Pixmap)',False) 'bglTexFromPixmap(Pixmap)
 End Method 

 Method SetClamp(U:Int,V:Int)
  If u Then ClampU=True Else ClampU=0
  If v Then ClampV=True Else ClampV=0
 End Method 

 Function Load:TTexture(Filename:String,maskred:Int=-1,maskgreen:Int=-1,maskblue:Int=-1)

  DebugLogOpenGL "TTexture.Load "+Filename$

  '----------------------------------------------

  Local TD:TTexture
  For TD=EachIn TextureList
   If TD.File$=Filename$ Then
    Return TD
   EndIf
  Next

  '----------------------------------------------

  Local T:TTexture=New TTexture
  T.File$=Filename$
  T.ScaleU=1.0
  T.ScaleV=1.0
  T.PosU=0.0
  T.PosV=0.0
  T.Rotation=0.0
  Local pm:TPixmap=LoadPixmap(Filename$)  
  'glGetIntegerv(GL_MAX_TEXTURE_SIZE, &texSize);
  '... resize wenn zu gro ...
  '---------------------- Mask 
  If maskred=>0 And maskgreen=>0 And maskblue=>0 Then
   T.UseMask=True
   pm=MaskPixmap(pm,maskred,maskgreen,maskblue) 
  Else
   T.UseMask=False
  EndIf
  '----------------------
  T.Width=pm.Width
  T.Height=pm.Height

  T.Handle=GLTexFromPixmap(pm,True)',False) 'bglTexFromPixmap(pm) 'mit MipMap war alles wei ...
  pm=Null '; FlushMem

  TextureList.addlast T

  Return T
 End Function

 Method SetTextureScale(u:Double,v:Double)
  ScaleU=u
  ScaleV=v
 End Method 

 Method SetTexturePos(u:Double,v:Double)
  PosU=u
  PosV=v
 End Method 

 Method SetTextureRotation(Rot:Double)
  Rotation=Rot
 End Method 

End Type

'##############################################################################

Type TMesh
 Field Enabled:Int
 Field Compiled:Int
 Field CallList:Int
 Field Surfaces:TList

 Function Create:TMesh()
  DebugLogOpenGL "Create Mesh" 
  Local m:TMesh=New TMesh

  m.Surfaces=CreateList()
  m.Enabled=1
  Return m
 End Function

 Function Free(M:TMesh Var)

  If M.Compiled Then glDeleteLists M.CallList,1

  Local S:TSurface
  For S=EachIn M.Surfaces
   TSurface.Free S
  Next

  M.Surfaces=Null
  M=Null

 End Function

 Method Copy:TMesh(Compile:Int=False)
  Local M:TMesh=TMesh.Create()
  M.Enabled=Enabled
  Local Surface:TSurface
  For Surface=EachIn Surfaces
   M.AddSurface Surface.Copy()
  Next
  If Compile Then M.Compile()
  Return M
 End Method

 Method FlipVertices(x:Double,y:Double,z:Double)
  x=Sgn(x)
  y=Sgn(y)
  z=Sgn(z)

  Local Surface:TSurface
  Local Vertex:TVertex
  For Surface=EachIn Surfaces
   For Vertex=EachIn Surface.Vertices
    Vertex.x=Vertex.x*x
    Vertex.y=Vertex.y*y
    Vertex.z=Vertex.z*z
    Vertex.nx=Vertex.nx*x
    Vertex.ny=Vertex.ny*y
    Vertex.nz=Vertex.nz*z
   Next
  Next
 End Method

 Method Scale(x:Double,y:Double,z:Double)
  Local Surface:TSurface
  Local Vertex:TVertex
  For Surface=EachIn Surfaces
   For Vertex=EachIn Surface.Vertices
    Vertex.x=Vertex.x*x
    Vertex.y=Vertex.y*y
    Vertex.z=Vertex.z*z
   Next
  Next
 End Method

 Method NewSurface:TSurface(Typ:Int=GL_TRIANGLES)
  Local S:TSurface=TSurface.Create(Typ)
  Surfaces.addlast S
  Return S 
 End Method

 Method AddSurface(S:TSurface)
  Surfaces.addlast S
 End Method

 Method AddTube(Segmente:Int=10)
  '...
 End Method

 Method AddCylinder(ho:Double=10,ra1:Double=5,ra2:Double=5,wi:Double=359,Segmente:Double=10)

  Local Surface:TSurface 
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Vertex4:TVertex

  Local wist:Double=359.999/Segmente
  
  Local y:Double=0.0

  Local x1o:Double,x2o:Double,z1o:Double,z2o:Double
  Local x1u:Double,x2u:Double,z1u:Double,z2u:Double

  Local nx:Double,nz:Double
  Local y1:Double,y2:Double

  Surface=Self.NewSurface(GL_QUADS)

  'don't read (The last Vertices must End (< 0.0) = 359.99 degrees Or the cylindrical UV mapping don't work) 

  Repeat   
   y1= ho/2
   y2=-ho/2

   x1o=x2o
   x2o=Sin(y)*ra1
   z1o=z2o
   z2o=Cos(y)*ra1

   x1u=x2u
   x2u=Sin(y)*ra2
   z1u=z2u
   z2u=Cos(y)*ra2

   If y>0.0 Then
	Vertex1=TVertex.Create(x1u,y2,z1u,1, 0) 'first use simple UVs and later uv mapping :)
	Vertex2=TVertex.Create(x1o,y1,z1o,1,-1)
    Vertex3=TVertex.Create(x2o,y1,z2o,0,-1)
    Vertex4=TVertex.Create(x2u,y2,z2u,0, 0)
    nx= Sin(y)
    nz=-Cos(y)
  	Vertex1.VertexNormal(nx,0.0,nz)
	Vertex2.VertexNormal(nx,0.0,nz)
	Vertex3.VertexNormal(nx,0.0,nz)
	Vertex4.VertexNormal(nx,0.0,nz)
  	Surface.AddQuad Vertex1,Vertex2,Vertex3,Vertex4
   EndIf
  
   y=y+wist
   If y>wi+wist Then Exit 
  Forever

  'to do ... UV mapping ...

  Self.AddDisc  ho/2, ho/2,ra1,ra2,wi+1,wist  'Oben
  Self.AddDisc -ho/2,-ho/2,ra1,ra2,wi+1,wist  'Unten
 End Method

 Method AddDisc(hi:Double,ha:Double,ra1:Double,ra2:Double,wi:Double,wist:Double)

  Local Surface:TSurface 
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Vertices:TList=CreateList()
  Local x:Double,y:Double
  Local a1:Double,b1:Double,a2:Double,b2:Double

  Surface=TSurface.Create(GL_TRIANGLES)
  Self.AddSurface Surface      

  wi=wi-1.0

  y=0.0

  Repeat   
 
   a1=Sin(y)*ra1
   b1=Cos(y)*ra2

   a2=Sin(y+wist)*ra1
   b2=Cos(y+wist)*ra2

   Vertex1=TVertex.Create(0,hi,ra2, 0.0, 0.0)
   Vertex2=TVertex.Create(a1,ha,b1, 1.0, 0.0)
   Vertex3=TVertex.Create(a2,ha,b2, 1.0, 1.0)

   Vertices.Addlast Vertex1
   Vertices.Addlast Vertex2
   Vertices.Addlast Vertex3

   If hi=>0.0 Then
	Vertex1.VertexNormal( 0.0, 1.0, 0.0)
	Vertex2.VertexNormal( 0.0, 1.0, 0.0)
	Vertex3.VertexNormal( 0.0, 1.0, 0.0)
    Surface.AddTriangle Vertex1,Vertex2,Vertex3 
   Else
	Vertex1.VertexNormal( 0.0,-1.0, 0.0)
	Vertex2.VertexNormal( 0.0,-1.0, 0.0)
	Vertex3.VertexNormal( 0.0,-1.0, 0.0)
    Surface.AddTriangle Vertex3,Vertex2,Vertex1 
   EndIf

   y=y+wist
   If y>wi+wist Then Exit
  Forever

  Self.PlanarUVMapXZ Vertices,1,1
  Vertices=Null

 End Method

 Method AddPlaneXY(width:Double,height:Double)
  Local Surface:TSurface 
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Vertex4:TVertex
  Local x:Double,y:Double

  x=width/2.0
  y=height/2.0

	'Front
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x,  y, 0, 0.0, 0.0)
	Vertex2=TVertex.Create( x,  y, 0, 1.0, 0.0)
	Vertex3=TVertex.Create( x, -y, 0, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, -y, 0, 0.0, 1.0)

	Vertex1.VertexNormal(0.0, 0.0, 1.0)
	Vertex2.VertexNormal(0.0, 0.0, 1.0)
	Vertex3.VertexNormal(0.0, 0.0, 1.0)
	Vertex4.VertexNormal(0.0, 0.0, 1.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

 End Method

 Method AddPlaneXZ(width:Double,depth:Double)
  Local Surface:TSurface 
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Vertex4:TVertex
  Local x:Double,z:Double

  x=width/2.0
  z=depth/2.0

	'Bottom
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x, 0, -z, 0.0, 0.0)
	Vertex2=TVertex.Create( x, 0, -z, 1.0, 0.0)
	Vertex3=TVertex.Create( x, 0,  z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, 0,  z, 0.0, 1.0)

	Vertex1.VertexNormal( 0.0, 1.0, 0.0)
	Vertex2.VertexNormal( 0.0, 1.0, 0.0)
	Vertex3.VertexNormal( 0.0, 1.0, 0.0)
	Vertex4.VertexNormal( 0.0, 1.0, 0.0) 

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

 End Method

 Method AddCube(width:Double,height:Double,depth:Double)

  Local Surface:TSurface 
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Vertex4:TVertex
  Local x:Double,y:Double,z:Double

  x=width/2.0
  y=height/2.0
  z=depth/2.0

	'Front
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x,  y, z, 0.0, 0.0)
	Vertex2=TVertex.Create( x,  y, z, 1.0, 0.0)
	Vertex3=TVertex.Create( x, -y, z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, -y, z, 0.0, 1.0)

	Vertex1.VertexNormal(0.0, 0.0, 1.0)
	Vertex2.VertexNormal(0.0, 0.0, 1.0)
	Vertex3.VertexNormal(0.0, 0.0, 1.0)
	Vertex4.VertexNormal(0.0, 0.0, 1.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

	'Back
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create( x,  y, -z, 0.0, 0.0)
	Vertex2=TVertex.Create(-x,  y, -z, 1.0, 0.0)
	Vertex3=TVertex.Create(-x, -y, -z, 1.0, 1.0)
	Vertex4=TVertex.Create( x, -y, -z, 0.0, 1.0)

	Vertex1.VertexNormal(0.0, 0.0, -1.0)
	Vertex2.VertexNormal(0.0, 0.0, -1.0)
	Vertex3.VertexNormal(0.0, 0.0, -1.0)
	Vertex4.VertexNormal(0.0, 0.0, -1.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4
		
	'Top
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x, y, -z, 0.0, 0.0)
	Vertex2=TVertex.Create( x, y, -z, 1.0, 0.0)
	Vertex3=TVertex.Create( x, y,  z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, y,  z, 0.0, 1.0)

	Vertex1.VertexNormal( 0.0, 1.0, 0.0)
	Vertex2.VertexNormal( 0.0, 1.0, 0.0)
	Vertex3.VertexNormal( 0.0, 1.0, 0.0)
	Vertex4.VertexNormal( 0.0, 1.0, 0.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

	'Bottom
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x, -y,  z, 0.0, 0.0)
	Vertex2=TVertex.Create( x, -y,  z, 1.0, 0.0)
	Vertex3=TVertex.Create( x, -y, -z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, -y, -z, 0.0, 1.0)

	Vertex1.VertexNormal( 0.0, -1.0, 0.0)
	Vertex2.VertexNormal( 0.0, -1.0, 0.0)
	Vertex3.VertexNormal( 0.0, -1.0, 0.0)
	Vertex4.VertexNormal( 0.0, -1.0, 0.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

	'Left
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x,  y, -z, 0.0, 0.0)
	Vertex2=TVertex.Create(-x,  y,  z, 1.0, 0.0)
	Vertex3=TVertex.Create(-x, -y,  z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, -y, -z, 0.0, 1.0)

	Vertex1.VertexNormal( -1.0, 0.0, 0.0)
	Vertex2.VertexNormal( -1.0, 0.0, 0.0)
	Vertex3.VertexNormal( -1.0, 0.0, 0.0)
	Vertex4.VertexNormal( -1.0, 0.0, 0.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4
		
	'Right
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(x,  y,  z, 0.0, 0.0)
	Vertex2=TVertex.Create(x,  y, -z, 1.0, 0.0)
	Vertex3=TVertex.Create(x, -y, -z, 1.0, 1.0)
	Vertex4=TVertex.Create(x, -y,  z, 0.0, 1.0)

	Vertex1.VertexNormal( 1.0, 0.0, 0.0)
	Vertex2.VertexNormal( 1.0, 0.0, 0.0)
	Vertex3.VertexNormal( 1.0, 0.0, 0.0)
	Vertex4.VertexNormal( 1.0, 0.0, 0.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

 End Method
 '--------------
 Method AddTorus(OuterRadius:Double,InnerRadius:Double,Segments:Double,Sides:Double)

  Local Surface:TSurface 
  Local V1:TVertex
  Local V2:TVertex
  Local V3:TVertex
  Local V4:TVertex
  Local N:TVertex=TVertex.Create(0,0,0)
	
  Local KreisStep:Double=360.0/Segments 'Kreis Vorne
  Local RingStep:Double=360.0/Sides     'Kreis Seite
  Local TorRad:Double
  Local RingRad:Double

  RingRad=(OuterRadius-InnerRadius)/2.0
  TorRad=InnerRadius+RingRad

  Local x1:Double,y1:Double,z1:Double
  Local x2:Double,y2:Double,z2:Double
  Local x3:Double,y3:Double,z3:Double
  Local x4:Double,y4:Double,z4:Double

  Local kreis:Double
  Local ring:Double

  Surface=TSurface.Create(GL_QUADS)
  Self.AddSurface Surface      

   Kreis=-KreisStep/2.0
   Repeat
    ring=-RingStep/2.0
    Repeat

 	    x1=(torrad+(Sin(ring)*ringrad))*Cos(kreis)
 	    y1=(torrad+(Sin(ring)*ringrad))*Sin(kreis)
 	    z1=((Cos(ring)*ringrad))

 	    x2=(torrad+(Sin(ring)*ringrad))*Cos(kreis+KreisStep)
 	    y2=(torrad+(Sin(ring)*ringrad))*Sin(kreis+KreisStep)
 	    z2=z1

 	    x3=(torrad+(Sin(ring+RingStep)*ringrad))*Cos(kreis+KreisStep)
 	    y3=(torrad+(Sin(ring+RingStep)*ringrad))*Sin(kreis+KreisStep)
 	    z3=((Cos(ring+RingStep)*ringrad))

 	    x4=(torrad+(Sin(ring+RingStep)*ringrad))*Cos(kreis)
 	    y4=(torrad+(Sin(ring+RingStep)*ringrad))*Sin(kreis)
 	    z4=z3

		'UVs ? naja

			V1=TVertex.Create(x1,y1,z1, 0,0)
			V2=TVertex.Create(x2,y2,z2, 1,0)			
			V3=TVertex.Create(x3,y3,z3, 1,1)			
			V4=TVertex.Create(x4,y4,z4, 0,1)			
			TriangleNormal v1,v2,v3,N
			V1.VertexNormal -N.x,-N.y,-N.z			
			V2.VertexNormal -N.x,-N.y,-N.z			
			V3.VertexNormal -N.x,-N.y,-N.z			
			V4.VertexNormal -N.x,-N.y,-N.z			
            Surface.AddQuad V1,V2,V3,V4

			ring=ring+RingStep	
		Until ring=>360.0-RingStep/2.0

		kreis=kreis+KreisStep
	Until kreis=>360.0-KreisStep/2.0
	
    N=Null
				
 End Method

 '--------------
 Method AddTerrainBorder(SizeXZ:Double,Height:Double)

  Local Surface:TSurface 
  Local Vertex1:TVertex
  Local Vertex2:TVertex
  Local Vertex3:TVertex
  Local Vertex4:TVertex
  Local x:Double,y:Double,z:Double

  x=SizeXZ/2.0
  y=Height
  z=SizeXZ/2.0

	'Front
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create( x, y, z, 0.0, 0.0)
	Vertex2=TVertex.Create(-x, y, z, 1.0, 0.0)
	Vertex3=TVertex.Create(-x, 0, z, 1.0, 1.0)
	Vertex4=TVertex.Create( x, 0, z, 0.0, 1.0)

	Vertex1.VertexNormal(0.0, 0.0,-1.0)
	Vertex2.VertexNormal(0.0, 0.0,-1.0)
	Vertex3.VertexNormal(0.0, 0.0,-1.0)
	Vertex4.VertexNormal(0.0, 0.0,-1.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

	'Back
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x, y, -z, 0.0, 0.0)
	Vertex2=TVertex.Create( x, y, -z, 1.0, 0.0)
	Vertex3=TVertex.Create( x, 0, -z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, 0, -z, 0.0, 1.0)

	Vertex1.VertexNormal(0.0, 0.0,  1.0)
	Vertex2.VertexNormal(0.0, 0.0,  1.0)
	Vertex3.VertexNormal(0.0, 0.0,  1.0)
	Vertex4.VertexNormal(0.0, 0.0,  1.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4
		
	'Left
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(-x, y, -z, 0.0, 0.0)
	Vertex2=TVertex.Create(-x, y,  z, 1.0, 0.0)
	Vertex3=TVertex.Create(-x, 0,  z, 1.0, 1.0)
	Vertex4=TVertex.Create(-x, 0, -z, 0.0, 1.0)

	Vertex1.VertexNormal(1.0, 0.0, 0.0)
	Vertex2.VertexNormal(1.0, 0.0, 0.0)
	Vertex3.VertexNormal(1.0, 0.0, 0.0)
	Vertex4.VertexNormal(1.0, 0.0, 0.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4
		
	'Right
    Surface=TSurface.Create(GL_QUADS)
    Self.AddSurface Surface      

	Vertex1=TVertex.Create(x, y,  z, 0.0, 0.0)
	Vertex2=TVertex.Create(x, y, -z, 1.0, 0.0)
	Vertex3=TVertex.Create(x, 0, -z, 1.0, 1.0)
	Vertex4=TVertex.Create(x, 0,  z, 0.0, 1.0)

	Vertex1.VertexNormal(-1.0, 0.0, 0.0)
	Vertex2.VertexNormal(-1.0, 0.0, 0.0)
	Vertex3.VertexNormal(-1.0, 0.0, 0.0)
	Vertex4.VertexNormal(-1.0, 0.0, 0.0)

    Surface.AddVertex Vertex1
    Surface.AddVertex Vertex2
    Surface.AddVertex Vertex3
    Surface.AddVertex Vertex4

 End Method

 Method AddQuad(Width:Double,Steps:Double)

  Local Surface:TSurface
  Local Vertices:TList=CreateList()
  Local Vertex:TVertex

  Surface=TSurface.Create(GL_TRIANGLES)
  Self.AddSurface Surface      

  '----------------------------------- Eckpunkte erzeugen

  Local x:Double,z:Double
  Local u:Double,v:Double

  x=-width/2.0
  Repeat
   z=-width/2.0
   Repeat
    u= x/width 
    v= z/width 

    Vertex=TVertex.Create(x,0,z,0.5+u,0.5+v)
	Vertex.VertexNormal( 0.0, 1.0, 0.0) 'bei Z=1 siehts richtig aus
	Vertices.AddLast Vertex
 
    z=z+Steps;If z>width/2.0 Then Exit
   Forever
   x=x+Steps;If x>width/2.0 Then Exit
  Forever

  '----------------------------------- Dreiecke

  'von Liste in Array bertragen weil ich die mit Index anspreche
  Local Vi:TVertex[CountList(Vertices)]
  Local c:Int=0
  For Vertex=EachIn Vertices
   Vi[c]=Vertex
   c=c+1
  Next
  
  'jetzt die Dreiecke erzeugen
  Local i:Int
  Local db:Int=0
  c=0
  For i=0 To CountList(Vertices)-(width/Steps+3)
   c=c+1
   db=1-db
   If c< (width/Steps)+1 Then
    If db=1 Then
     Surface.AddTriangle Vi[i]  ,Vi[i+1]                    ,Vi[i+(width+Steps)/Steps]
     Surface.AddTriangle Vi[i+1],Vi[i+(width+Steps)/Steps+1],Vi[i+(width+Steps)/Steps]
    Else
     Surface.AddTriangle Vi[i]  ,Vi[i+(width+Steps)/Steps+1],Vi[i+(width+Steps)/Steps]
     Surface.AddTriangle Vi[i]  ,Vi[i+1]                    ,Vi[i+(width+Steps)/Steps+1]
    EndIf
   Else
    c=0
   EndIf
  Next 

  Vertices=Null

 End Method

 Method AddHeightMap(FileName$,Size:Double,Height:Double)

  Local Map:TPixmap
  Local x:Double,y:Double,z:Double
  Local u:Double,v:Double
  Local ARGB:Int

  Local Surface:TSurface
  Local Vertices:TList=CreateList()
  Local Vertex:TVertex
  Local Normal:TVertex=TVertex.Create(0,0,0)

  Surface=TSurface.Create(GL_QUADS)
  Self.AddSurface Surface      

  Map=LoadPixmap(FileName$)
  Map=ResizePixmap(Map,128,128)

  Local cx:Double;cx=-Size/2.0
  Local cz:Double;cz=-Size/2.0

  For x=0 To map.Width-1
   For z=0 To map.Height-1
    ARGB=ReadPixel(map,x,z)
    y=(ARGB_Red(ARGB)+ARGB_Green(ARGB)+ARGB_Blue(ARGB))/3.0/256.0
    u= x/(map.Width-1)
    v= z/(map.Height-1)
    Vertex=TVertex.Create(cx+x/(map.Width-1)*Size,y*Height,cz+z/(map.Height-1)*Size,u,v)
	Vertex.VertexNormal( 0.0, 1.0, 0.0) 
	Vertices.AddLast Vertex
   Next  
  Next

  '----------------------------------- Vierecke

  'von Liste in Array bertragen weil ich die mit Index anspreche
  Local Vi:TVertex[CountList(Vertices)]
  Local c:Int=0
  For Vertex=EachIn Vertices
   Vi[c]=Vertex
   c=c+1
  Next
  
  'jetzt die Vierecke erzeugen
  Local i:Int
  c=0
  For i=0 To CountList(Vertices)-2-map.width
   c=c+1
   If c< map.Width Then
     TriangleNormal Vi[i],Vi[i+1],Vi[i+map.width+1],Normal

 	 Vi[i].VertexNormal(Normal.x,Normal.y,Normal.z) 
 	 Vi[i+1].VertexNormal(Normal.x,Normal.y,Normal.z) 
 	 Vi[i+map.width+1].VertexNormal(Normal.x,Normal.y,Normal.z) 
 	 Vi[i+map.width].VertexNormal(Normal.x,Normal.y,Normal.z) 

     Surface.AddVertex Vi[i]
     Surface.AddVertex Vi[i+1]             
     Surface.AddVertex Vi[i+map.width+1]
     Surface.AddVertex Vi[i+map.width]
   Else
    c=0
   EndIf
  Next 

  Normal=Null

  Map=Null	
  Vertices=Null
	
 End Method

 Method PlanarUVMapXZ(Vertices:TList,SetU:Double=1,SetV:Double=1) 'TOP

  ' Map all vertices from XZ plane
  ' with vertex coordinates

  Local Vertex:TVertex

  Local u:Double,v:Double

  Local minu:Double = 3.4*10^38	
  Local maxu:Double = -3.4*10^38
  Local minv:Double = 3.4*10^38
  Local maxv:Double = -3.4*10^38

  For Vertex=EachIn Vertices
   u = Vertex.X
   v = Vertex.Z
   If u<minu Then minu = u
   If u>maxu Then maxu = u
   If v<minv Then minv = v
   If v>maxv Then maxv = v
   Vertex.U=u
   Vertex.V=v
   Vertex.W=1.0
  Next
	
	' Scale all uv coordinates To be between
	' 0.0 And 1.0
  Local uscale:Double = Abs(maxu-minu)/setu
  Local vscale:Double = Abs(maxv-minv)/setv
  If uscale=0.0 Then uscale=1.0
  If vscale=0.0 Then vscale=1.0
			
  For Vertex=EachIn Vertices
   u = (Vertex.U+minu)/uscale
   v = (Vertex.V+minv)/vscale
   Vertex.U=u
   Vertex.V=-v
   Vertex.W=1.0
  Next

 End Method

 Method SetTexture(Tex:TTexture,ScaleU:Double=0.0,ScaleV:Double=0.0)
  Local Surface:TSurface
  'Use loaded Texture Scale as default
  If ScaleU=0 Then ScaleU=Tex.ScaleU
  If ScaleV=0 Then ScaleV=Tex.ScaleV
  For Surface=EachIn Self.Surfaces
   Surface.SetTexture Tex,ScaleU,ScaleV
  Next
 End Method

 Method SetVertexColor(Red:Double,Green:Double,Blue:Double,Alpha:Double=1.0)
  Local Surface:TSurface
  Local V:TVertex
  For Surface=EachIn Self.Surfaces
   For V=EachIn Surface.Vertices
    V.R=Red
    V.G=Green
    V.B=Blue
    V.A=Alpha
   Next 
  Next
 End Method

 Method SetFaces(Front:Int=1,Back:Int=1)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.SetFaces Front,Back
  Next
 End Method

 Method SetDiffuseColor(Red:Float,Green:Float,Blue:Float,Alpha:Float=1.0)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.DIFFUSE=[Red,Green,Blue,Alpha]
  Next
 End Method

 Method SetAmbient(Red:Float,Green:Float,Blue:Float,Alpha:Float)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.Ambient=[Red,Green,Blue,Alpha] 
  Next
 End Method

 Method SetDiffuse(Red:Float,Green:Float,Blue:Float,Alpha:Float)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.Diffuse=[Red,Green,Blue,Alpha] 
  Next
 End Method

 Method SetEmission(Red:Float,Green:Float,Blue:Float,Alpha:Float)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.Emission=[Red,Green,Blue,Alpha] 
  Next
 End Method

 Method SetShininess(Red:Float,Green:Float,Blue:Float,Alpha:Float)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.Shininess=[Red,Green,Blue,Alpha] 
  Next
 End Method

 Method SetSpecular(Red:Float,Green:Float,Blue:Float,Alpha:Float)
  Local Surface:TSurface
  For Surface=EachIn Self.Surfaces
   Surface.Specular=[Red,Green,Blue,Alpha] 
  Next
 End Method

 Method Render()
  If Compiled=0 Then
   Local S:TSurface
   For S=EachIn Surfaces
    S.Render
   Next
  Else
   glCallList(CallList)
  EndIf
 End Method

 Method Compile()
  If Compiled=0 Then
   Compiled=1
   CallList=glGenLists(1)
   glNewList (CallList,GL_COMPILE)
   Local S:TSurface
   For S=EachIn Surfaces
    S.Render
   Next
   glEndList()
  EndIf
 End Method

 Method NoCompile()
  If Compiled=1 Then
   glDeleteLists CallList,1
   Compiled=0
  EndIf
 End Method

 Method Move(mx:Double,my:Double,mz:Double,pitch:Double=0,yaw:Double=0,roll:Double=0)
   Local Matrix:Double[4,4]
   Local S:TSurface
   Local V:TVertex
   Local nx:Double,ny:Double,nz:Double

   glPushMatrix()

   glMatrixMode GL_MODELVIEW
   glLoadIdentity()

   glRotated pitch,1.0,0.0,0.0
   glRotated yaw  ,0.0,1.0,0.0
   glRotated roll ,0.0,0.0,1.0

   glTranslated mx,my,mz
			
   glGetDoublev(GL_MODELVIEW_MATRIX,Matrix)

   For S=EachIn Surfaces
    For V=EachIn S.Vertices

      'Transform Position
      nx=v.x
      ny=v.y
      nz=v.z
      'Rotieren
      v.x= nx * Matrix[0, 0] + ny * Matrix[1, 0] + nz * Matrix[2, 0]
      v.y= nx * Matrix[0, 1] + ny * Matrix[1, 1] + nz * Matrix[2, 1]
      v.z= nx * Matrix[0, 2] + ny * Matrix[1, 2] + nz * Matrix[2, 2]
      'Bewegen
      v.x=v.x + mx * Matrix[0, 0] + my * Matrix[1, 0] + mz * Matrix[2, 0]
      v.y=v.y + mx * Matrix[0, 1] + my * Matrix[1, 1] + mz * Matrix[2, 1]
      v.z=v.z + mx * Matrix[0, 2] + my * Matrix[1, 2] + mz * Matrix[2, 2]

      'Transform Normal
      nx=v.nx
      ny=v.ny
      nz=v.nz
      v.nx= nx * Matrix[0, 0] + ny * Matrix[1, 0] + nz * Matrix[2, 0]
      v.ny= nx * Matrix[0, 1] + ny * Matrix[1, 1] + nz * Matrix[2, 1]
      v.nz= nx * Matrix[0, 2] + ny * Matrix[1, 2] + nz * Matrix[2, 2]
	
    Next
   Next

   glPopMatrix()

 End Method

 '... Center ...

End Type

'##############################################################################

Type TTriangle

 'only for Triangle List and Ray Intersection

 Field V1:TV3D
 Field V2:TV3D
 Field V3:TV3D

 Function Create:TTriangle(V1:TV3D,V2:TV3D,V3:TV3D)
  Local T:TTriangle=New TTriangle
  T.V1=V1
  T.V2=V2
  T.V3=V3
  Return T
 End Function

 Function Free(T:TTriangle Var)
  T.V1=Null
  T.V2=Null
  T.V3=Null
  T=Null
 End Function
 
End Type

'##############################################################################

Type TSurface
 Field Enabled:Int
 Field Vertices:TList
 Field SurfaceTyp:Int
 Field Name:String
 Field Texture:TTexture
 Field Faces:Int

 Field AMBIENT:Float[4]  
 Field DIFFUSE:Float[4]
 Field EMISSION:Float[4]
 Field SHININESS:Float[4]
 Field SPECULAR:Float[4] 'Spiegelreflexion

 Function Create:TSurface(Typ:Int=GL_TRIANGLES)
  DebugLogOpenGL "Create Surface" 
  Local s:TSurface=New TSurface
  s.SurfaceTyp=Typ
  s.Name$="No Name"
  s.Texture=Null
  s.Faces=GL_FRONT
  s.Vertices=CreateList()
  s.Enabled=1

  s.AMBIENT  =[1.0, 1.0, 1.0, 1.0] 'Umgebung
  s.DIFFUSE  =[1.0, 1.0, 1.0, 1.0] '
  s.EMISSION =[0.1, 0.1, 0.1, 1.0] 'Leutet
  s.SHININESS=[0.0, 0.0, 0.0, 0.0] 'Glanz 
  s.SPECULAR =[0.0, 0.0, 0.0, 0.0] 'Spiegelreflexion

  If Typ=GL_QUADS Or Typ=GL_TRIANGLES Or Typ=GL_POINTS Then
   'OK
  Else
   DebugLogOpenGL "ERR:TSurface.Create use only Type = GL_TRIANGLES or GL_QUADS or GL_POINTS !"
  EndIf
  Return s
 End Function

 Function Free(S:TSurface Var)
  Local V:TVertex
  For V=EachIn S.Vertices
   TVertex.Free V
  Next
  S.Vertices=Null
  S.Texture=Null
  S=Null
 End Function

 Method GetTriangleList:TList(x:Double,y:Double,z:Double) 

  'creates a list with triangles and translate it to a global position from static non rotated entitys
  
  'look at TIntersectTree and TEntity

  'x,y,z Offset from Entity

  Local L:TList=CreateList()
  Local Vertex :TVertex
  Local C:Int=0
  Local V0:TV3D
  Local V1:TV3D
  Local V2:TV3D
  Local V3:TV3D

  'Vertex copieren weil die dann eine Global Position bekommen

  If SurfaceTyp=GL_TRIANGLES Then
			For Vertex = EachIn Vertices
			 c=c+1
			 Select c
			 Case 1;v0=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 Case 2;v1=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 Case 3;v2=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 End Select	
			 If c=3 Then
			    c=0
			    L.Addlast TTriangle.Create(v0,v1,v2)		
		     EndIf 'one Triangle
			Next 'Vertices
  ElseIf SurfaceTyp=GL_QUADS Then
			For Vertex = EachIn Vertices
			 c=c+1
			 Select c
			 Case 1;v0=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 Case 2;v1=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 Case 3;v2=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 Case 4;v3=TV3D.Create(x+Vertex.x,y+Vertex.y,z+Vertex.z)
			 End Select	
			 If c=4 Then
			    c=0		
			    L.Addlast TTriangle.Create(v0,v1,v2)		
			    L.Addlast TTriangle.Create(v0,v2,v3)		
		     EndIf 'two Triangles
			Next 'Vertices
  EndIf

  Return L
 End Method

 Method Copy:TSurface()
  Local Surface:TSurface=TSurface.Create()
  Surface.Enabled=Enabled
  Surface.SurfaceTyp=SurfaceTyp
  Surface.Name$=Name$
  Surface.Texture=Texture
  Surface.Faces=Faces
  Surface.AMBIENT=AMBIENT
  Surface.DIFFUSE=DIFFUSE
  Surface.EMISSION=EMISSION
  Surface.SHININESS=SHININESS
  Surface.SPECULAR=SPECULAR
  Local V:TVertex
  For V=EachIn Vertices
   Surface.AddVertex V.Copy()
  Next
  Return Surface
 End Method

 Method GetVertices:TList()
  Return Vertices
 End Method

 Method SetTexture(Tex:TTexture,ScaleU:Double=1.0,ScaleV:Double=1.0)
  If Tex=Null Then DebugLogOpenGL "ERR:TSurface.SetTexture Parameter Tex=0 !?"
  Texture=Tex
  Texture.ScaleU=ScaleU
  Texture.ScaleV=ScaleV
 End Method

 Method SetFaces(Front:Int=1,Back:Int=1)
  Faces=0
  If Front<>0 And Back<>0 Then 
   Faces=GL_FRONT_AND_BACK
  Else
   If Front Then Faces=GL_FRONT
   If Back Then Faces=GL_BACK
  EndIf
 End Method

 Method AddVertex(V:TVertex)
  Vertices.addlast V
 End Method

 Method AddTriangle(V1:TVertex,V2:TVertex,V3:TVertex)
  Vertices.addlast V1
  Vertices.addlast V2
  Vertices.addlast V3
 End Method

 Method AddQuad(V1:TVertex,V2:TVertex,V3:TVertex,V4:TVertex)
  Vertices.addlast V1
  Vertices.addlast V2
  Vertices.addlast V3
  Vertices.addlast V4
 End Method

 Method Render()
  Local V:TVertex

  '---------------------------------------------------------------------------
  'Immer Alpha benutzen
  glEnable(GL_BLEND)
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) '! siehe TTexture.Create

  If Texture<>Null Then
   If Texture.UseMask=True Then
    '... Alpha
   EndIf
   glEnable GL_TEXTURE_2D  
   glBindTexture GL_TEXTURE_2D,Texture.Handle 
   Local Matrix:Int
   glGetIntegerv(GL_MATRIX_MODE, Varptr(Matrix))
   glMatrixMode(GL_TEXTURE)
   glLoadIdentity()
   glTranslated(Texture.PosU,Texture.PosV, 0.0)
   glRotated(Texture.Rotation, 0.0, 0.0, 1.0)
   glScaled(Texture.ScaleU,Texture.ScaleV, 1.0)
   glMatrixMode(Matrix)
	If Texture.ClampU Then
	 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP)
	Else
	 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT)
	EndIf

	If Texture.ClampV Then
	 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP)
	Else
	 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT)
	EndIf

  EndIf 'Texture are there
  '---------------------------------------------------------------------------

  Select SurfaceTyp
  Case GL_TRIANGLES
   glBegin GL_TRIANGLES
  Case GL_QUADS
   glBegin GL_QUADS
  Case GL_POINTS
   glBegin GL_POINTS
  Default
   glBegin GL_TRIANGLES
  End Select

  '---------------------------------------------------------------------------
  'face :  GL_FRONT, GL_BACK, GL_FRONT_AND_BACK 
  If Faces Then
   glMaterialfv (Faces,GL_AMBIENT  , AMBIENT  ) 
   glMaterialfv (Faces,GL_DIFFUSE  , DIFFUSE  )
   glMaterialfv (Faces,GL_EMISSION , EMISSION ) 
   glMaterialfv (Faces,GL_SHININESS, SHININESS)
   glMaterialfv (Faces,GL_SPECULAR , SPECULAR) 
  EndIf

  'glEnable(GL_COLOR_MATERIAL)

  '---------------------------------------------------------------------------

  For V=EachIn Vertices
   V.Render
  Next

  glEnd											

  '---------------------------------------------------------------------------
  If Texture<>Null Then
   'If Texture.UseMask=True Then glDisable GL_BLEND
   glDisable GL_TEXTURE_2D  
  EndIf
  '---------------------------------------------------------------------------

 End Method

End Type

'##############################################################################

Type TVertex
 Field x:Double,y:Double,z:Double 'Pos
 Field u:Double,v:Double,w:Double 'Texture 
 Field r:Double,g:Double,b:Double 'Farbe
 Field a:Double 'Alpha
 Field nx:Double,ny:Double,nz:Double 'Normal

 Function Create:TVertex(px:Double,py:Double,pz:Double,tu:Double=0,tv:Double=0,tw:Double=0)
  'DebugLog "Create Vertex" 
  Local v:TVertex=New TVertex

  v.x=px 'relative Position to Entity
  v.y=py
  v.z=pz

  v.u=tu 'Texture
  v.v=tv
  v.w=tw

  v.r=0.0 'Color
  v.g=0.0
  v.b=0.0
  v.a=1 'Alpha 1=Visible to 0=Hidden

  v.nx=0 'default Normal
  v.ny=0
  v.nz=1

  Return v
 End Function

 Function Free(V:TVertex Var)
  V=Null
 End Function

 Method Copy:TVertex()
  Local V:TVertex=TVertex.Create(x,y,z,u,v,w)

  V.r=r
  V.g=g
  V.b=b

  V.a=a

  V.nx=nx
  V.ny=ny
  V.nz=nz

  Return V
 End Method

 Method VertexTransform(M:TMatrix)
  Local V:TV3D=TV3D.Create(x,y,z)
  VTrans V,M
  x=V.x
  y=V.y
  z=V.z
  V=Null
 End Method

 Method VertexScale(sx:Double,sy:Double,sz:Double) 
  x=x*sx
  y=y*sy
  z=z*sz
 End Method

 Method VertexMove(mx:Double,my:Double,mz:Double)
  x=x+mx
  y=y+my
  z=z+mz
 End Method

 Method VertexColor(red:Double,green:Double,blue:Double,alpha:Double=1.0)
  'You can see Vertex Color without Lights
  r=red
  g=green
  b=blue
  a=alpha
 End Method

 Method VertexTexCoords(tu:Double=0,tv:Double=0,tw:Double=0)
  u=tu
  v=tv
  w=tw
 End Method

 Method VertexNormal(normalx:Double,normaly:Double,normalz:Double)
  nx=normalx
  ny=normaly
  nz=normalz
 End Method

 Method Render()
  'DebugLog "Render Vertex" 
		glTexCoord2d u,v
		'glTexCoord3f u,v,w '???
        glColor4d r,g,b,a 'wenn kein Licht benutzt wird geht das mit Alpha !?
        'glColor3f r,g,b  
        glNormal3d nx, ny, nz
		glVertex3d x,y,z
 End Method

End Type

'##############################################################################

Type T3DFont

 Field Texture:TTexture[256]
 Field x:Int[256]
 Field y:Int[256]
 Field w:Int[256]
 Field h:Int[256]
 Field uScale:Double[256] 'because the char textures size are power of 2
 Field vScale:Double[256] 

 Field Alpha:Double[256]

 Function Create:T3DFont(FileName$="")

  Local F:T3DFont=New T3DFont

  '-------------------------------
  If Len(FileName$)>0 Then
   Local pm:TPixmap=LoadPixmap(FileName$)
   pm=ConvertPixmap(pm,PF_RGBA8888)

   'DebugLog ReadPixel(pm,0,0)

   Local FileNameFontInfo$=StripExt(FileName$)+".xywh"
   Local st:TStream
   Local c:Int  
   st=ReadFile(FileNameFontInfo$) 
   Local dummy$=ReadLine(st)
   DebugLogOpenGL dummy$
   For c=0 To 255
    F.x[c]=ReadInt(st)
    F.y[c]=ReadInt(st)
    F.w[c]=ReadInt(st)
    F.h[c]=ReadInt(st)
    F.Alpha[c]=1.0
   Next
   CloseFile st

   Local pmchar:TPixmap
   For c=0 To 255
    pmchar=Grab(pm,F.x[c],F.y[c],F.w[c],F.h[c])
    F.Texture[c]=TTexture.CreateFromPixmap(pmchar,248,0,248) 'Magenta Mask for 16 Bit BMP Font Image
    F.uScale[c]=Double(F.w[c])/Double(F.Texture[c].Width)
    F.vScale[c]=Double(F.h[c])/Double(F.Texture[c].Height)
    F.Texture[c].ClampU=True
    F.Texture[c].ClampV=True

    pmchar=Null
   Next
   pm=Null
  EndIf 'Len FileName >0
  '-------------------------------

  Return F
 End Function

 Function Free(F:T3DFont Var)
  Local T:TTexture
  Local I:Int
  For I=0 To 255
   If F.Texture[i]<>Null Then TTexture.Free F.Texture[i]
  Next  
  F=Null
 End Function

 Method LoadCharImage(Char$,FileName$,Width:Double=0,Height:Double=0,AlphaValue:Double=1.0)
  Local c:Int=Asc(Char$)
  If Texture[c]<>Null Then TTexture.Free Texture[c]
  Texture[c]=TTexture.Load(FileName$)
  Texture[c].ClampU=True
  Texture[c].ClampV=True
  x[c]=0
  y[c]=0
  If Width=0 Then 
   w[c]=Texture[c].Width
   uScale[c]=w[c]/Texture[c].Width
  Else
   w[c]=Width
   uScale[c]=1.0
  EndIf
  If Height=0 Then 
   h[c]=Texture[c].Height
   vScale[c]=h[c]/Texture[c].Height
  Else
   h[c]=Height
   vScale[c]=1.0
  EndIf
  Alpha[c]=AlphaValue
 End Method

 Method SetAllCharAlpha(AlphaValue:Double=1.0)
  Local c:Int
  For c=0 To 255
   Alpha[c]=AlphaValue
  Next
 End Method

 Method Render(Tx:String,x:Double,y:Double,xrot:Double=0,yrot:Double=0,zrot:Double=0,scalex:Double=1,scaley:Double=1)

  If Len(Tx)=0 Then Return

  y=-y

  glPushMatrix()

  Local l:Int=glIsEnabled(GL_LIGHTING)
  If l Then glDisable GL_LIGHTING

  glMatrixMode GL_MODELVIEW							'Select The ModelView Matrix
  glLoadIdentity										'Reset The ModelView Matrix

    glEnable(GL_BLEND)
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) '! siehe TTexture.Create

    glEnable GL_TEXTURE_2D  

	glTranslated 0,0,-20 'before Camera

	glTranslated x/10.0,y/10.0,0
	
	glRotated xrot,1.0,0.0,0.0 'X Axis
	glRotated yrot,0.0,1.0,0.0 'Y Axis
	glRotated zrot,0.0,0.0,1.0 'Z Axis

    glScaled scalex/10.0,scaley/10.0,1 'else to big

    Local i:Int
    Local c:Int 
    Local Width:Int=0
    Local Height:Int=0

    For i=1 To Len(Tx)
     c=Asc(Mid(Tx,i,1))
     Width=Width+w[c]
     Height=Height+h[c]
    Next
    Height=Height/Len(Tx)

    Local Matrix:Int
    x=-Width / 2.0 'start position
    y= Height/ 2.0

    For i=1 To Len(Tx)
     c=Asc(Mid(Tx,i,1))

     If Texture[c]<>Null Then

      '-------------------------------------------- Char Texture
	  glBindTexture GL_TEXTURE_2D,Texture[c].Handle 
      glGetIntegerv(GL_MATRIX_MODE, Varptr(Matrix))
      glMatrixMode(GL_TEXTURE) 'aufpassen weil die an anderer Stelle berschrieben wird !
      glLoadIdentity()
      glTranslated(Texture[c].PosU,Texture[c].PosV, 0.0)
      glRotated(Texture[c].Rotation, 0.0, 0.0, 1.0)
      glScaled(Texture[c].ScaleU,Texture[c].ScaleV, 1.0)
      glMatrixMode(Matrix)
      'no repeating !
	  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP)
	  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP)
      '--------------------------------------------

      Local a:Double=Alpha[c]
      Local w:Double=w[c]
      Local h:Double=h[c]
      Local u:Double
      Local v:Double

      u=uScale[c] 
      v=vScale[c] 

      glBegin GL_QUADS

	  glTexCoord2d 0.0,0.0
      glColor4d 1,1,1,a
      glNormal3d 0,0,1
	  glVertex3d x,y,0.0

	  glTexCoord2d u,0.0
      glColor4d 1,1,1,a
      glNormal3d 0,0,1
	  glVertex3d x+w,y,0.0

	  glTexCoord2d u,v
      glColor4d 1,1,1,a
      glNormal3d 0,0,1
	  glVertex3d x+w,y-h,0.0

	  glTexCoord2d 0.0,v
      glColor4d 1,1,1,a
      glNormal3d 0,0,1
	  glVertex3d x,y-h,0.0

      glEnd
      x=x+w

     EndIf 'only there was a Texture loaded !

	Next 

   glDisable GL_TEXTURE_2D  
   glDisable GL_BLEND

   If l Then glEnable(GL_LIGHTING)

   glPopMatrix()
	
 End Method

End Type

'---------------------------------------------------------------

Function myGraphics:TGraphics(width:Int,height:Int,depth:Int=16,herz:Int=0)

 Local flags:Int=GRAPHICS_BACKBUFFER | GRAPHICS_DEPTHBUFFER
 'If depth Then flags=flags | GRAPHICS_FULLSCREEN

 SetGraphicsDriver GLGraphicsDriver()

 glContext=GLGraphics(width,height,depth,herz,flags) '< BMax 1.12
 glViewport 0,0,width,height

 glDepthFunc GL_LESS
 glEnable GL_DEPTH_TEST								'Enables Depth Testing
 glShadeModel GL_SMOOTH

 glMatrixMode GL_PROJECTION							'Select The Projection Matrix
 glLoadIdentity										'Reset The Projection Matrix
 Local fish:Double
 fish=1.2
 glFrustum -10.33*fish,10.33*fish,-10*fish,10*fish, 10.0,200000.0			'Setup The Projection Matrix Frustum
 glMatrixMode GL_MODELVIEW							'Select The ModelView Matrix
 glLoadIdentity										'Reset The ModelView Matrix

 glClearColor(0.75,0.75,0.75,1) 					'Wie ClsColor aber mit Werte von 0-1 !

 Return glContext

End Function

'---------------------------------------------------------------

Function Camera(PosX:Double,PosY:Double,PosZ:Double,TargetX:Double,TargetY:Double,TargetZ:Double)
    glLoadIdentity()
	gluLookAt PosX,PosY,PosZ, TargetX,TargetY,TargetZ, 0,1,0  
End Function

Function CameraLikeEntity(CamEntity:TEntity)

 'Heureka , schwere Geburt :-)

   Local M:TMatrix
   Local MP:TMatrix
   Local MT:TMatrix
   M:TMatrix=TMatrix.Create()
   MP:TMatrix=TMatrix.Create() 
   MT:TMatrix=TMatrix.Create()

   MatrixCreateIdentity(MP)

      '---------------------------------- 
		Local TransformList:TList, Entity:TEntity
		
		' Hierarchically Transformation
		If CamEntity.Parent Then
			TransformList = CreateList()
			Entity = CamEntity.Parent
			While Entity <> Null
				TransformList.Addfirst(Entity)
				Entity = Entity.Parent
			Wend
			'TransformList.Reverse()
		
			For Entity = EachIn TransformList
             MatrixEntity Entity ,MT
             MatrixMultiply MT,MP,M
             MatrixCopy M,MP
			Next
			TransformList =Null
		EndIf

      MatrixEntity CamEntity,MT
      MatrixMultiply MT,MP,M	
	
      '----------------------------------
	
   Local PosX:Double,PosY:Double,PosZ:Double
   Local TargetX:Double,TargetY:Double,TargetZ:Double
   Local UpX:Double,UpY:Double,UpZ:Double

   PosX=M.A[3, 0]
   PosY=M.A[3, 1]
   PosZ=M.A[3, 2]

   TargetX=M.A[3, 0]-M.A[2,0] 'Pos+AchseZ
   TargetY=M.A[3, 1]-M.A[2,1]
   TargetZ=M.A[3, 2]-M.A[2,2]

   UpX=M.A[1,0] 'Achse Y
   UpY=M.A[1,1]
   UpZ=M.A[1,2]

   glLoadIdentity()

   gluLookAt PosX,PosY,PosZ,TargetX,TargetY,TargetZ,UpX,UpY,UpZ

   M=Null
   MP=Null
   MT=Null
	
End Function

'---------------------------------------------------------------

Function ARGB_Alpha:Int(ARGB:Int)

 Return Int((ARGB & $FF000000:Int) / $1000000:Int)

End Function

Function ARGB_Red:Int(ARGB:Int)
 
 Return Int((ARGB & $00FF0000:Int) / $10000:Int)

End Function

Function ARGB_Green:Int(ARGB:Int)

 Return Int((ARGB & $0000FF00:Int) / $100:Int)
 
End Function

Function ARGB_Blue:Int(ARGB:Int)

 Return (ARGB & $000000FF:Int)

End Function

Function ARGB_Color:Int(Alpha:Int,Red:Int,Green:Int,Blue:Int)

 Return (Alpha*$1000000:Int+Red*$10000:Int+Green*$100:Int+Blue)

End Function

'---------------------------------------------------------------

Function TriangleNormal(p1:TVertex,p2:TVertex,p3:TVertex,n:TVertex Var)

 'MR 16.07.2005
  
 'Oberflchen Normale von einer Ebene mit 3 Punkten (Dreieck)
 
  Local a:TVertex=TVertex.Create(0,0,0)
  Local b:TVertex=TVertex.Create(0,0,0)

  'Sub

  a.x = p2.x - p1.x
  a.y = p2.y - p1.y
  a.z = p2.z - p1.z

  b.x = p3.x - p1.x
  b.y = p3.y - p1.y
  b.z = p3.z - p1.z
	
  'gibt Vectorprodukt zurck
 
  n.x = a.y * b.z - b.y * a.z
  n.y = a.z * b.x - b.z * a.x
  n.z = a.x * b.y - b.x * a.y

  Local fa:Double
 
  'Dotprodukt - Skalarprodukt
  fa = Sqr(n.x*n.x + n.y*n.y + n.z*n.z)
 
  'Vector Normieren auf lnge 1.0

  If fa = 0 Then
   n.x = 0.0
   n.y = 0.0
   n.z = 0.0
  Else
   fa = 1.0 / fa
   n.x = n.x * fa
   n.y = n.y * fa
   n.z = n.z * fa
  End If

  a=Null
  b=Null
 
End Function

'--------------------------------

Function Grab:TPixmap(pm:TPixmap,x:Int,y:Int,w:Int,h:Int)

 'For BMP Font

 Local xx:Int,yy:Int
 Local tw:Int=8,th:Int=8
 While tw<w 
  tw=tw*2
 Wend
 While th<h 
  th=th*2
 Wend

 Local pmchar:TPixmap=CreatePixmap(tw,th,PF_RGBA8888) 'not x^2

 For xx=0 To tw-1
  For yy=0 To th-1
   WritePixel pmchar,xx,yy,$00F800F8
  Next
 Next 

 'DebugLog "w="+w+" h="+h
 'DebugLog "tw="+tw+" th="+th
 Local col:Int

 For xx=x To x+w-1
  For yy=y To y+h-1
   col=ReadPixel(pm,xx,yy)
   'If ARGB_Red(col)=248 And ARGB_Green(col)=0 And ARGB_Blue(col)=248 Then col=0
   WritePixel pmchar,xx-x,yy-y,col
  Next
 Next

 Return pmchar

End Function

'--------------------------------

Function DebugLogOpenGL(Txt$)

  If DebugLogOpenGLOn Then DebugLog Txt$

End Function

'--------------------------------
'File END


