
'#################################################################################################
' Vector Include by M.Rauch 31.08.2005
' MR_Vector.bmx
'#################################################################################################

'http://www.euclideanspace.com/maths/algebra/matrix/

'History
'28.08.2005
'Changing Float to Double
'31.08.2005
'VHALF

'----------------------------------------------------------------------

Type TV3D
 Field x:Double
 Field y:Double
 Field z:Double
 
 Function Create:TV3D(x:Double=0,y:Double=0,z:Double=0)
  Local T:TV3D=New TV3D
  T.x=x
  T.y=y
  T.z=z
  Return T
 End Function

 Method Set(x:Double,y:Double,z:Double=0)
  self.x=x
  self.y=y
  self.z=z
 End Method 

 'Method Draw(xx:Double=0,yy:Double=0)
 ' DrawLine xx,yy,xx+x*10.0,yy+y*10.0 'TEST
 'End Method 

 Method Inv()
  x=-x
  y=-y
  z=-z
 End Method 

 Method Clr()
  self.x=0
  self.y=0
  self.z=0
 End Method 
 
End Type

'---------------------------------------------------------------

Type TMatrix
 Field A:Double[4,4]

 Function Create:TMatrix()
  Local M:TMatrix = New TMatrix
  Return M
 End Function

End Type

'--------------------------------

Function VNORMAL(p1:TV3D,p2:TV3D,p3:TV3D,n:TV3D Var)

 'MR 09.07.2005
  
 'Oberflchen Normale von einer Ebene mit 3 Punkten (Dreieck)
 
  Local a:TV3D=TV3D.Create()
  Local b:TV3D=TV3D.Create()

  VSUB p2,p1,a
  VSUB p3,p1,b
	
  VCROSS a,b,n

  a=Null
  b=Null

  VNORMALIZE n

End Function

'--------------------------------

Function VNORMALIZE(a:TV3D Var)

 'MR 05.07.2005
  
 'gibt Normvector zurck , aufpassen auf berlauf !

 'also gesamt Vector auf lnge 1 bringen 

 Local fa:Double
 
 fa = Sqr(VDOT(a, a))
 
 If fa = 0 Then
  a.x = 0.0
  a.y = 0.0
  a.z = 0.0
 Else
  fa = 1.0 / fa
  a.x = a.x * fa
  a.y = a.y * fa
  a.z = a.z * fa
 End If
 
End Function

'--------------------------------

Function VDOT:Double(a:TV3D, b:TV3D)
 
 'MR 05.07.2005

 'Dotprodukt - Skalarprodukt
 
 'berechnet ein Skalarprodukt zweier Vectoren
 
 Return (a.x * b.x + a.y * b.y + a.z * b.z)
 
End Function

'--------------------------------

Function VCROSS(a:TV3D,b:TV3D,c:TV3D Var)
 
 'MR 05.07.2005
  
 'gibt Vectorprodukt zurck
 
 c.x = a.y * b.z - b.y * a.z
 c.y = a.z * b.x - b.z * a.x
 c.z = a.x * b.y - b.x * a.y
 
End Function

'--------------------------------

Function VADD(v1:TV3D, v2:TV3D,vout:TV3D Var) 

 'MR 05.07.2005
 
 '+
 
 vout.x = v1.x + v2.x
 vout.y = v1.y + v2.y
 vout.z = v1.z + v2.z

End Function

'--------------------------------

Function VSUB(v1:TV3D, v2:TV3D,vout:TV3D Var) 

 'MR 05.07.2005
 
 '-
 
 vout.x = v1.x - v2.x
 vout.y = v1.y - v2.y
 vout.z = v1.z - v2.z

End Function

'--------------------------------

Function VMUL(v1:TV3D, v2:TV3D,vout:TV3D Var)

 'MR 05.07.2005
 
 '*
 
 vout.x = v1.x * v2.x
 vout.y = v1.y * v2.y
 vout.z = v1.z * v2.z

End Function

'--------------------------------

Function VDIR(a:TV3D, b:TV3D,vd:TV3D Var)

 'MR 05.07.2005

 Local hyp:Double
 
 VSUB b,a,vd
 
 hyp = Sqr(vd.x * vd.x + vd.y * vd.y + vd.z * vd.z)
 
 If hyp <> 0.0 Then
  vd.x = vd.x / hyp
  vd.y = vd.y / hyp
  vd.z = vd.z / hyp
 Else
  vd.x = 0.0
  vd.y = 0.0
  vd.z = 0.0
 End If
 
 'returns vector in vd
 
End Function

'--------------------------------

Function VENT:Double(a:TV3D, b:TV3D) 
 
 'MR 05.07.2005
  
 'Entfernung

 Local ve:TV3D=TV3D.Create()
 Local e:Double 

 VSUB b, a,ve
  
 e = Sqr(ve.x * ve.x + ve.y * ve.y + ve.z * ve.z)

 ve=Null

 Return e 
 
End Function

'--------------------------------

Function VHALF(v1:TV3D, v2:TV3D,vout:TV3D Var) 

 'MR 31.08.2005
 
 'middle Vector between v1 and v2
 
 vout.x = (v1.x + v2.x) / 2.0
 vout.y = (v1.y + v2.y) / 2.0
 vout.z = (v1.z + v2.z) / 2.0

End Function

'----------------------------------------------------------------------

Function VENTXY:Double(a:TV3D,b:TV3D)
 Local dx:Double,dy:Double
 dx=b.x-a.x 
 dy=b.y-a.y 

 Return Sqr(dx*dx + dy*dy)
End Function

'--------------------------------

Function VCOPY(v:TV3D, vout:TV3D Var) 

 'MR 05.07.2005
 
 '=
 
 vout.x = v.x
 vout.y = v.y
 vout.z = v.z

End Function

'-------------------------------------------------------------------------------------------------

Function VTRANS(a:TV3D Var,M:TMatrix)

 'MR 09.07.2005

 'berschribt den Vector ! AUFPASSEN ! 

 Local b:TV3D=TV3D.Create()
 
 'DebugLog "vorher A.xyz"

 'DebugLog a.x
 'DebugLog a.y
 'DebugLog a.z

 b.x = a.x * M.A[0, 0] + a.y * M.A[1, 0] + a.z * M.A[2, 0] 
 b.y = a.x * M.A[0, 1] + a.y * M.A[1, 1] + a.z * M.A[2, 1] 
 b.z = a.x * M.A[0, 2] + a.y * M.A[1, 2] + a.z * M.A[2, 2] 

 'ByRef
  
 a.x = b.x
 a.y = b.y
 a.z = b.z

 'DebugLog "nacher A.xyz"

 'DebugLog a.x
 'DebugLog a.y
 'DebugLog a.z

 'DebugLog "Matrix"

 'DebugLog M.A[0,0]
 'DebugLog M.A[0,1]
 'DebugLog M.A[0,2]

 'DebugLog M.A[1,0]
 'DebugLog M.A[1,1]
 'DebugLog M.A[1,2]

 'DebugLog M.A[2,0]
 'DebugLog M.A[2,1]
 'DebugLog M.A[2,2]

 b=Null
 
End Function

'-------------------------------------------------------------------------------------------------

Function VTRANS2(a:TV3D Var,M:TMatrix) 

 'benutzt von TEntity.Translate

 Local b:TV3D=TV3D.Create() 
  
 b.x = a.x * M.A[0, 0] + a.y * M.A[0, 1] + a.z * M.A[0, 2] 
 b.y = a.x * M.A[1, 0] + a.y * M.A[1, 1] + a.z * M.A[1, 2] 
 b.z = a.x * M.A[2, 0] + a.y * M.A[2, 1] + a.z * M.A[2, 2] 

 'ByRef 
  
 a.x = b.x 
 a.y = b.y 
 a.z = b.z 

 b=Null 
  
End Function 

'-------------------------------------------------------------------------------------------------

Function MatrixZero(M:TMatrix Var)
 
 'MR 09.07.2005
 
 Local i, j
 
 For i = 0 To 3
  For j = 0 To 3
   M.A[i, j] = 0.0
  Next 
 Next 
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixCopy(M:TMatrix,MOut:TMatrix Var)
 
 'MR 09.07.2005
 
 Local i, j
 
 For i = 0 To 3
  For j = 0 To 3
   MOut.A[i, j] = M.A[i, j]
  Next 
 Next 
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixCreateIdentity(M:TMatrix Var)

 'MR 11.08.2005

 MatrixZero M

 Local i 

 For i = 0 To 3
  M.A[i, i] = 1.0
 Next 
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixCreateTranslate(a:TV3D,M:TMatrix Var)
 
 'MR 09.07.2005
 
 MatrixCreateIdentity M
 
 M.A[3, 0] = a.x
 M.A[3, 1] = a.y
 M.A[3, 2] = a.z
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixCreateAxisRotate(axis:TV3D,Angle:Double,M:TMatrix Var)

 'MR 09.07.2005
 
 Local sqraxis:TV3D=TV3D.Create()
 
 sqraxis.x = sqare(axis.x)
 sqraxis.y = sqare(axis.y)
 sqraxis.z = sqare(axis.z)
 
 Local cosine:Double
 
 cosine = Cos(Angle)
 
 Local sine:Double
 
 sine = Sin(Angle)
 
 Local one_minus_cosine:Double
 
 one_minus_cosine = 1.0 - cosine
 
 MatrixZero M
 
 M.A[0, 0] = sqraxis.x + (1.0 - sqraxis.x) * cosine
 M.A[0, 1] = axis.x * axis.y * one_minus_cosine + axis.z * sine
 M.A[0, 2] = axis.x * axis.z * one_minus_cosine - axis.y * sine
 
 M.A[1, 0] = axis.x * axis.y * one_minus_cosine - axis.z * sine
 M.A[1, 1] = sqraxis.y + (1.0 - sqraxis.y) * cosine
 M.A[1, 2] = axis.y * axis.z * one_minus_cosine + axis.x * sine
 
 M.A[2, 0] = axis.x * axis.z * one_minus_cosine + axis.y * sine
 M.A[2, 1] = axis.y * axis.z * one_minus_cosine - axis.x * sine
 M.A[2, 2] = sqraxis.z + (1.0 - sqraxis.z) * cosine
 
 M.A[3, 3] = 1.0
 
 sqraxis=Null

End Function

'-------------------------------------------------------------------------------------------------

Function MatrixCreateScale(a:TV3D,M:TMatrix Var)
 
 'MR 09.07.2005

 MatrixZero M
 
 M.A[0, 0] = a.x
 M.A[1, 1] = a.y
 M.A[2, 2] = a.z
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixMultiply(M1:TMatrix,M2:TMatrix,MOut:TMatrix Var)

 'MR 09.07.2005
 
 'Multipliziert Matrix 1 & 2
 
 Local i,j
 
 For i = 0 To 3
  For j = 0 To 3
   MOut.A[i, j] = M1.A[i, 0] * M2.A[0, j] + M1.A[i, 1] * M2.A[1, j] + M1.A[i, 2] * M2.A[2, j] + M1.A[i, 3] * M2.A[3, j]
  Next
 Next
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixDebugLog(M:TMatrix)

 'MR 09.07.2005
 
 'Als Debug Ausgabe
 
 DebugLog "MatrixDebug"

 Local i,j
 
 For i = 0 To 3
  For j = 0 To 3
   DebugLog M.A[i, j]
  Next
 Next
 
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixEntity(Entity:TEntity,MOut:TMatrix Var)
  
 'MR 01.08.2005
    
  MOut.A[0, 0] = Entity.AchseX.x
  MOut.A[0, 1] = Entity.AchseY.x
  MOut.A[0, 2] = Entity.AchseZ.x
  MOut.A[0, 3] = 0
  MOut.A[1, 0] = Entity.AchseX.y
  MOut.A[1, 1] = Entity.AchseY.y
  MOut.A[1, 2] = Entity.AchseZ.y
  MOut.A[1, 3] = 0
  MOut.A[2, 0] = Entity.AchseX.z
  MOut.A[2, 1] = Entity.AchseY.z
  MOut.A[2, 2] = Entity.AchseZ.z
  MOut.A[2, 3] = 0
  MOut.A[3, 0] = Entity.Pos.x
  MOut.A[3, 1] = Entity.Pos.y
  MOut.A[3, 2] = Entity.Pos.z
  MOut.A[3, 3] = 1
  
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixEntityAxis(Entity:TEntity,MOut:TMatrix Var)
  
 'MR 01.08.2005
    
  MOut.A[0, 0] = Entity.AchseX.x
  MOut.A[0, 1] = Entity.AchseY.x
  MOut.A[0, 2] = Entity.AchseZ.x
  MOut.A[0, 3] = 0
  MOut.A[1, 0] = Entity.AchseX.y
  MOut.A[1, 1] = Entity.AchseY.y
  MOut.A[1, 2] = Entity.AchseZ.y
  MOut.A[1, 3] = 0
  MOut.A[2, 0] = Entity.AchseX.z
  MOut.A[2, 1] = Entity.AchseY.z
  MOut.A[2, 2] = Entity.AchseZ.z
  MOut.A[2, 3] = 0
  MOut.A[3, 0] = 0
  MOut.A[3, 1] = 0
  MOut.A[3, 2] = 0
  MOut.A[3, 3] = 1
  
End Function

'-------------------------------------------------------------------------------------------------

Function MatrixQuaternion(x:Double,y:Double,z:Double,w:Double,MOut:TMatrix Var) 'not tested ! converted from Java Sample

 'MR 28.07.2005

 Local xx:Double = X * X
 Local xy:Double = X * Y
 Local xz:Double = X * Z
 Local xw:Double = X * W

 Local yy:Double = Y * Y
 Local yz:Double = Y * Z
 Local yw:Double = Y * W

 Local zz:Double = Z * Z
 Local zw:Double = Z * W

 MOut.A[0, 0] = 1.0 - 2.0 * ( yy + zz )
 MOut.A[0, 1] = 2.0 * ( xy - zw )
 MOut.A[0, 2] = 2.0 * ( xz + yw )
 MOut.A[0, 3] = 0
 MOut.A[1, 0] = 2.0 * ( xy + zw ) 
 MOut.A[1, 1] = 1.0 - 2.0 * ( xx + zz )
 MOut.A[1, 2] = 2.0 * ( yz - xw )
 MOut.A[1, 3] = 0
 MOut.A[2, 0] = 2.0 * ( xz - yw )
 MOut.A[2, 1] = 2.0 * ( yz + xw )
 MOut.A[2, 2] = 1.0 - 2.0 * ( xx + yy )
 MOut.A[2, 3] = 0
 MOut.A[3, 0] = 0
 MOut.A[3, 1] = 0 
 MOut.A[3, 2] = 0
 MOut.A[3, 3] = 1

End Function

'-------------------------------------------------------------------------------------------------

Function Sqare:Double(x:Double)

 'MR 09.07.2005

 Return (x * x)

End Function

'-------------------------------------------------------------------------------------------------

'Ergebnis.X=X*XAchse.X + X*YAchse.X + X*ZAchse.X + Position.X;
'Ergebnis.Y=Y*XAchse.Y + Y*YAchse.Y + Y*ZAchse.Y + Position.Y;
'Ergebnis.Z=Z*XAchse.Z + Y*YAchse.Z + Y*ZAchse.Z + Position.Z;
